void CFemmviewView::DoContours(CDC *pDC,double *p,int side,int Aflag)
{
	int i,j,k;
	static double m[4][3];
	static int u[4];
	double *swap;
	double hi,lo,a,b,z;

	CFemmviewDoc *pDoc=GetDocument();

	switch(side)
	{
		case 0 : u[0]=p[0]; u[1]=p[1]; u[2]=p[1]; u[3]=p[2]; break;
		case 1 : u[0]=p[1]; u[1]=p[2]; u[2]=p[2]; u[3]=p[0]; break;
		default: u[0]=p[2]; u[1]=p[0]; u[2]=p[0]; u[3]=p[1]; break;
	}
	
	for(i=0;i<3;i++){
		m[i][0]=(double) meshnode[u[i]].xs;
		m[i][1]=(double) meshnode[u[i]].ys;
		if (Aflag==0) m[i][2]=meshnode[u[i]].A.re;
		else m[i][2]=meshnode[u[i]].A.im;
	}
	
	// scale A for easier analysis.
	for(i=0;i<3;i++) m[i][2]=NumContours*(m[i][2]-pDoc->A_Low)/
							 (pDoc->A_High-pDoc->A_Low);

	// swap around so that lowest magnitude is first point in
	// each line...
	if (m[0][2]>m[1][2]){
		swap=m[1];
		m[1]=m[0];
		m[0]=swap;
	}
	if (m[2][2]>m[3][2]){
		swap=m[3];
		m[3]=m[2];
		m[2]=swap;
	}

	// figure out which contours lie in this section
	lo=m[0][2]; if(m[2][2]>lo) lo=m[2][2];
	hi=m[1][2]; if(m[3][2]<hi) hi=m[3][2];
	if(fabs(hi-lo)<0.0000000001){
		for(i=0;i<4;i++) free(m[i]);
		free(m);
		return;
	}
	j=(int) ceil(lo); k=(int) floor(hi);

	for(i=j;i<=k;i++){
		z=(double) i;
		a=(z-m[0][2])/(m[1][2]-m[0][2]);
		b=(z-m[2][2])/(m[3][2]-m[2][2]);
		pDC->MoveTo((int) ((m[1][0]-m[0][0])*a+m[0][0]),
			        (int) ((m[1][1]-m[0][1])*a+m[0][1]));
		pDC->LineTo((int) ((m[3][0]-m[2][0])*b+m[2][0]),
					(int) ((m[3][1]-m[2][1])*b+m[2][1]));
	}
}
