// femmviewView.cpp : implementation of the CFemmviewView class
//

#include "stdafx.h"
#include <afx.h>
#include <afxtempl.h>
#include "femmview.h"
#include "complex.h"
#include "problem.h"
#include "xyplot.h"
#include "femmviewDoc.h"
#include "femmviewView.h"
#include "GridMod.h"
#include "GetPoint.h"
#include "CPlotDlg.h"
#include "MainFrm.h"
#include "KbdZoom.h"
#include "CPlotDlg2.h"
#include "DPlotDlg1.h"
#include "DPlotDlg2.h"
#include "MyMsgBox.h"
#include "XYPlotDlg.h"
#include "LIntDlg.h"
#include "BlockInt.h"
#include "CircDlg.h"


#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView

IMPLEMENT_DYNCREATE(CFemmviewView, CView)

BEGIN_MESSAGE_MAP(CFemmviewView, CView)
	//{{AFX_MSG_MAP(CFemmviewView)
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_SNAP_GRID, OnSnapGrid)
	ON_COMMAND(ID_SHOW_MESH, OnShowMesh)
	ON_COMMAND(ID_SHOW_GRID, OnShowGrid)
	ON_COMMAND(ID_SET_GRID, OnSetGrid)
	ON_COMMAND(ID_CPLOT, OnCplot)
	ON_COMMAND(ID_DPLOT, OnDplot)
	ON_COMMAND(ID_ZOOM_NATURAL, OnZoomNatural)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_COMMAND(ID_ZOOM_WINDOW, OnZoomWindow)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_RELOAD, OnReload)
	ON_COMMAND(ID_MENU_AREA, OnMenuArea)
	ON_COMMAND(ID_MENU_CONTOUR, OnMenuContour)
	ON_COMMAND(ID_MENU_POINT, OnMenuPoint)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_MENU_PLOT, OnMenuPlot)
	ON_COMMAND(ID_MENU_INTEGRATE, OnMenuIntegrate)
	ON_COMMAND(ID_MENUSHOWPTS, OnMenushowpts)
	ON_COMMAND(ID_KBDZOOM, OnKbdZoom)
	ON_COMMAND(ID_SMOOTH, OnSmooth)
	ON_WM_ERASEBKGND()
	ON_WM_RBUTTONDBLCLK()
	ON_COMMAND(ID_PAN_DOWN, OnPanDown)
	ON_COMMAND(ID_PAN_LEFT, OnPanLeft)
	ON_COMMAND(ID_PAN_RIGHT, OnPanRight)
	ON_COMMAND(ID_PAN_UP, OnPanUp)
	ON_COMMAND(ID_HELP_FINDER, OnHelpFinder)
	ON_COMMAND(ID_VIEW_CIRCPROPS, OnViewCircprops)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

void MyMessageBox(CString s)
{
	CString z;
	char linfeed[3];
	int i;

	sprintf(linfeed,"%c%c",0x0D,0x0A);
	for(i=0;i<s.GetLength();i++)
		if (s[i]=='\n') z+=linfeed;
		else z+=s[i];

	CMyMsgBox msgdlg;
	msgdlg.m_mymsg=z;
	msgdlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView construction/destruction

CFemmviewView::CFemmviewView()
{
	// TODO: add construction code here
	EditAction=0;				// operate on nodes
	ox=0.; oy=0.; mag=100.;		// lower left corner is origin; 100 dpi
	GridSize=0.25;				// 1/4" grid
	GridFlag=FALSE;				// grid is OFF
	SnapFlag=FALSE;				// snap to grid is initally off
	MeshFlag=FALSE;				// don't try to show the mesh
	LegendFlag=TRUE;			// show legend for density plots
	GreyContours=FALSE;			// plot contours in greyscale
	FirstPoint=-1;
	ZoomWndFlag=FALSE;
	NumContours=19;
	ShowAr=TRUE; ShowAi=FALSE;
	DensityPlot=0;
	PtsFlag=TRUE;
	Coords=FALSE;
	DrawSelected=-1;


	//////////////////////////////
	// Default Colors           //
	//////////////////////////////

	// Greyscale Colormap
	Grey0=RGB(58,58,58);
	Grey1=RGB(76,76,76);
	Grey2=RGB(94,94,94);
	Grey3=RGB(112,112,112);
	Grey4=RGB(130,130,130);
	Grey5=RGB(148,148,148);
	Grey6=RGB(166,166,166);
	Grey7=RGB(184,184,184);
	Grey8=RGB(202,202,202);
	Grey9=RGB(220,220,220);
	GreyA=RGB(238,238,238);
	GreyB=RGB(255,255,255);

	// Newer Colormap
	Color0 =	RGB(255,63,81);
	Color1 =	RGB(255,66,134);
	Color2 =	RGB(255,83,187);
	Color3 =	RGB(255,80,233);
	Color4 =	RGB(229,83,255);
	Color5 = 	RGB(183,83,255);
	Color6 =	RGB(118,73,255);
	Color7 =	RGB(60,59,255);
	Color8 =	RGB(27,121,255);
	Color9 =	RGB(24,173,255);
	ColorA =	RGB(24,234,255);
	ColorB =	RGB(255,255,255);

	// Other colors
	SelColor    =  RGB(255,0,0);
	MeshColor   =  RGB(213,228,20);
	BlockColor  =  RGB(0,125,0);
	LineColor   =  RGB(0,0,255);
	RegionColor =  RGB(0,125,0);
	GridColor   =	RGB(0,0,255);
	BackColor   =  RGB(255,255,255);
	TextColor   =  RGB(0,0,0);
	NodeColor	 =	RGB(0,0,0);
	RealFluxLineColor = RGB(0,0,0);
	ImagFluxLineColor = RGB(128,128,128);

	CString comline=GetCommandLine();
	CString ucomline=comline;
	ucomline.MakeUpper();
	int lim=ucomline.Find("FEMMVIEW.EXE");
	comline=comline.Left(lim);
	if (comline[0]=='\"'){
		comline.SetAt(0,' ');
		comline.TrimLeft();
	}
  	//AfxMessageBox(comline);
	BinDir=comline;

	// Load in colors from the disk;
	FILE *fp;
	CString fname;
#ifdef _DEBUG
	fname="c:\\femmsrc\\install\\colors.dat";
#else
	fname=BinDir+"colors.dat";
#endif
	fp=fopen(fname,"rt");
	if (fp!=NULL)
	{
		BOOL flag=FALSE;
		char s[1024];
		char q[1024];
		char *v;
		int cr,cg,cb;
	
		// parse the file
		while (fgets(s,1024,fp)!=NULL)
		{
			sscanf(s,"%s",q);

			if( _strnicmp(q,"<SelColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  SelColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<MeshColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  MeshColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
			
			if( _strnicmp(q,"<BlockColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  BlockColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<NodeColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  NodeColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<BkgndColor>",12)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  BackColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<TextColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  TextColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
	
			if( _strnicmp(q,"<FluxRColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  RealFluxLineColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<FluxIColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  ImagFluxLineColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<LineColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  LineColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<RegionColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  RegionColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
	
			if( _strnicmp(q,"<GridColor>",10)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  GridColor=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
			if( _strnicmp(q,"<Color0>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color0=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color1>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color1=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color2>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color2=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
		
			if( _strnicmp(q,"<Color3>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color3=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color4>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color4=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color5>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color5=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
						
			if( _strnicmp(q,"<Color6>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color6=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color7>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color7=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color8>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color8=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Color9>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Color9=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			
			if( _strnicmp(q,"<ColorA>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  ColorA=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<ColorB>",8)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  ColorB=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey0>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey0=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey1>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey1=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey2>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey2=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey3>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey3=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey4>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey4=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey5>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey5=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

				if( _strnicmp(q,"<Grey6>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey6=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey7>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey7=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey8>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey8=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<Grey9>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  Grey9=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<GreyA>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  GreyA=RGB(cr,cg,cb);
			  q[0]=NULL;
			}

			if( _strnicmp(q,"<GreyB>",7)==0)
			{
			  v=StripKey(s);
			  sscanf(v,"%i	%i	%i",&cr,&cg,&cb);
			  GreyB=RGB(cr,cg,cb);
			  q[0]=NULL;
			}
		}
		fclose(fp);
	}

//	Dspl.Create(IDD_OUTBOX,NULL);
}

CFemmviewView::~CFemmviewView()
{
}

BOOL CFemmviewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView drawing
void CFemmviewView::ScreenToDwg(int xs, int ys, double *xd, double *yd, RECT *r)
{
	double x,y;
	x=(double) xs;
	y=(double) ys;

	*xd=x/mag+ox;
	*yd=(((double) r->bottom) - y- 1.)/mag + oy;
}

BOOL CFemmviewView::DwgToScreen(double xd, double yd, int *xs, int *ys, RECT *r)
{
	double x,y;
	x=mag*(xd-ox);
	y=((double) r->bottom)- 1. - mag*(yd-oy);
	if((fabs(x)>32000.) || (fabs(y)>32000.)) return FALSE;
	*xs = (int) (mag*(xd-ox));
	*ys = ((int) r->bottom) - 1 - ((int) (mag*(yd-oy)) );
	return TRUE;
}

void CFemmviewView::DoContours(CDC *pDC,int *p,int side,int Aflag)
{
	int i,j,k;
	static double q[4][4];
	static double *m[4];
	static int u[4];
	double *swap;
	double hi,lo,a,b,z,offset;
	double a0,a1,r0,r1,md;

	CFemmviewDoc *pDoc=GetDocument();
	
	switch(side)
	{
		case 0 : u[0]=p[0]; u[1]=p[1]; u[2]=p[1]; u[3]=p[2]; break;
		case 1 : u[0]=p[1]; u[1]=p[2]; u[2]=p[2]; u[3]=p[0]; break;
		default: u[0]=p[2]; u[1]=p[0]; u[2]=p[0]; u[3]=p[1]; break;
	}

	for(i=0;i<4;i++){
		m[i]=q[i];
		m[i][0]=(double) pDoc->meshnode[u[i]].xs;
		m[i][1]=(double) pDoc->meshnode[u[i]].ys;
		m[i][3]=pDoc->meshnode[u[i]].x;
		if (Aflag==0) m[i][2]=pDoc->meshnode[u[i]].A.re;
		else m[i][2]=pDoc->meshnode[u[i]].A.im;
	}

	// scale A for easier analysis.
	for(i=0;i<4;i++) m[i][2]=NumContours*(m[i][2]-pDoc->A_Low)/
							 (pDoc->A_High-pDoc->A_Low);
	offset=-NumContours*pDoc->A_Low/(pDoc->A_High-pDoc->A_Low);

	// swap around so that lowest magnitude is first point in
	// each line...
	if (m[0][2]>m[1][2]){
		swap=m[1];
		m[1]=m[0];
		m[0]=swap;
	}
	if (m[2][2]>m[3][2]){
		swap=m[3];
		m[3]=m[2];
		m[2]=swap;
	}

	// figure out which contours lie in this section
	lo=m[0][2]; if(m[2][2]>lo) lo=m[2][2];
	hi=m[1][2]; if(m[3][2]<hi) hi=m[3][2];
	if(fabs(hi-lo)<0.0000000001) return;
	j=(int) ceil(lo); k=(int) floor(hi);

	for(i=j;i<=k;i++)
	if((i>=0) && (i<NumContours)) {
		z=(double) i;
		a=(z-m[0][2])/(m[1][2]-m[0][2]);
		b=(z-m[2][2])/(m[3][2]-m[2][2]);
	
		if(pDoc->ProblemType==1){

			r0=m[0][3]; r1=m[1][3];
			if(fabs(r0)>1.e-06) a0=(m[0][2]-offset)/r0; else a0=0;
			if(fabs(r1)>1.e-06) a1=(m[1][2]-offset)/r1; else a1=0;
			md=(a0+a1)*(r0+r1)/4. + offset;

			if((md>m[0][2]) && (md<m[1][2]) && (fabs(2.*md-m[0][2]-m[1][2])>1.e-2))
			{
				a=(3.*m[0][2] + m[1][2] - 4.*md + 
					sqrt(pow(3.*m[0][2] + m[1][2] - 4.*md,2.) - 
		     	   8.*(m[0][2] + m[1][2] - 2.*md)*(m[0][2] - z)))/
				   (4.*(m[0][2] + m[1][2] - 2*md));
			}

		
			r0=m[2][3]; r1=m[3][3];
			if(fabs(r0)>1.e-06) a0=(m[2][2]-offset)/r0; else a0=0;
			if(fabs(r1)>1.e-06) a1=(m[3][2]-offset)/r1; else a1=0;
			md=(a0+a1)*(r0+r1)/4. + offset;

			if((md>m[2][2]) && (md<m[3][2]) && (fabs(2.*md-m[2][2]-m[3][2])>1.e-2))
			{
				b=(3.*m[2][2] + m[3][2] - 4.*md + 
					sqrt(pow(3.*m[2][2] + m[3][2] - 4.*md,2.) - 
					8.*(m[2][2] + m[3][2] - 2.*md)*(m[2][2] - z)))/
					(4.*(m[2][2] + m[3][2] - 2*md));
			}
		
		}	
	
		pDC->MoveTo((int) ((m[1][0]-m[0][0])*a+m[0][0]),
			        (int) ((m[1][1]-m[0][1])*a+m[0][1]));
		pDC->LineTo((int) ((m[3][0]-m[2][0])*b+m[2][0]),
					(int) ((m[3][1]-m[2][1])*b+m[2][1]));
		
		if(Aflag==0)
		pDC->SetPixel((int) ((m[3][0]-m[2][0])*b+m[2][0]),
					(int) ((m[3][1]-m[2][1])*b+m[2][1]), RealFluxLineColor );
		else
		pDC->SetPixel((int) ((m[3][0]-m[2][0])*b+m[2][0]),
					(int) ((m[3][1]-m[2][1])*b+m[2][1]), ImagFluxLineColor );
	}
}
////////////////
void CFemmviewView::PlotFluxDensity(CDC *pDC,CElement &elm,int flag)
{
	int i,j,k,n,lav;
	double b,bn[3],bh,bl,y,z;
	CComplex b1[3],b2[3];
	POINT ps[3];
	static double c[35][3],p[3][2];
	CFemmviewDoc *pDoc=GetDocument();

	if(pDoc->blocklist[elm.lbl].IsSelected==TRUE) return;
	const COLORREF mymap[]={
		Color0,Color1,Color2,Color3,
		Color4,Color5,Color6,Color7,
		Color8,Color9,ColorA,ColorB
	};	

	const COLORREF greymap[]=
		{Grey0,Grey1,Grey2,Grey3,
		 Grey4,Grey5,Grey6,Grey7,
		 Grey8,Grey8,GreyA,GreyB};

	for(i=0;i<3;i++){
		if (pDoc->Smooth==TRUE)
		{
			b1[i]=elm.b1[i];
			b2[i]=elm.b2[i];
		}
		else{
			b1[i]=elm.B1;
			b2[i]=elm.B2;
		}
	}

	if(pDoc->Frequency==0) flag=1;

	if(flag==1){
		bl=pDoc->B_lb;
		bh=pDoc->B_ub;
		for(i=0;i<3;i++)
			bn[i]=sqrt(b1[i].re*b1[i].re + b1[i].im*b1[i].im +
			   b2[i].re*b2[i].re + b2[i].im*b2[i].im);
	}

	else if(flag==2){
		bl=pDoc->B_lb;
		bh=pDoc->B_ub;
		for(i=0;i<3;i++)
			bn[i]=sqrt(b1[i].re*b1[i].re + b2[i].re*b2[i].re);
	}

	else{
		bl=pDoc->B_lb;
		bh=pDoc->B_ub;
		for(i=0;i<3;i++)
			bn[i]=sqrt(b1[i].im*b1[i].im + b2[i].im*b2[i].im);
	}
	
	if(bh==bl) return;
	else for(i=0;i<3;i++) bn[i]=12.*(bn[i]-bl)/(bh-bl);

	// find subtriangle edges;
	for(i=0,n=0;i<3;i++)
	{
		c[n][0]=(double) pDoc->meshnode[elm.p[i]].xs;
		c[n][1]=(double) pDoc->meshnode[elm.p[i]].ys;
		c[n][2]=bn[i];
		n++; if(n>34) return;
		j=i+1; if(j==3) j=0;
		p[0][0]=(double) pDoc->meshnode[elm.p[i]].xs;
		p[0][1]=(double) pDoc->meshnode[elm.p[i]].ys;
		p[1][0]=(double) pDoc->meshnode[elm.p[j]].xs;
		p[1][1]=(double) pDoc->meshnode[elm.p[j]].ys;
		p[2][0]=bn[i];
		p[2][1]=bn[j];
		if(p[2][0]<p[2][1])
			for(z=ceil(p[2][0]);z<p[2][1];z++)
			{
				y=(z-p[2][0])/(p[2][1]-p[2][0]);
				c[n][0]=(1.-y)*p[0][0] + y*p[1][0];
				c[n][1]=(1.-y)*p[0][1] + y*p[1][1];
				c[n][2]=(1.-y)*p[2][0] + y*p[2][1];
				if ((z>=0) && (z<12)) n++; 
				if(n>34) return;
			}
		else
			for(z=floor(p[2][0]);z>p[2][1];z--)
			{
				y=(z-p[2][0])/(p[2][1]-p[2][0]);
				c[n][0]=(1.-y)*p[0][0] + y*p[1][0];
				c[n][1]=(1.-y)*p[0][1] + y*p[1][1];
				c[n][2]=(1.-y)*p[2][0] + y*p[2][1];
				if ((z>=0) && (z<12)) n++; 
				if(n>34) return;
			}

	}

	// subtriangle vertices are now listed in the c[][] array.
	// there are n vertices.  Now, plot out these subtriangles;

	do{
		// find lowest vertex & neighbors;
		for(i=1,j=0;i<n;i++) if (c[i][2]<c[j][2]) j=i;
		i=j-1; if(i<0) i=n-1;
		k=j+1; if(k>=n) k=0;

		// plot triangle;
		b=(c[i][2]+c[j][2]+c[k][2])/3.;
		lav=11-((int) b);
		if(lav>11) lav=11;
		if(lav<0) lav=0;

		{
			CPen FillPen,*pOldPen;
			CBrush FillBrush,*pOldBrush;
			BOOL DrawIt=TRUE;

			if (GreyContours==FALSE){
				if(mymap[lav]==BackColor) DrawIt=FALSE;
				else{
					FillBrush.CreateSolidBrush(mymap[lav]);
					FillPen.CreatePen(PS_SOLID,1,mymap[lav]);
				}
			}
			else{
				if(greymap[lav]==BackColor) DrawIt=FALSE;
				else{
					FillBrush.CreateSolidBrush(greymap[lav]);
					FillPen.CreatePen(PS_SOLID,1,greymap[lav]);
				}
			}
			if(DrawIt==TRUE)
			{
				pOldBrush = pDC->SelectObject( &FillBrush );
				pOldPen = pDC->SelectObject( &FillPen );
				ps[0].x=(long) c[i][0]; ps[0].y=(long) c[i][1];
				ps[1].x=(long) c[j][0]; ps[1].y=(long) c[j][1];
				ps[2].x=(long) c[k][0]; ps[2].y=(long) c[k][1];
				pDC->Polygon(ps,3);	
				pDC->SelectObject(pOldPen);
				pDC->SelectObject(pOldBrush);
			}
		}

		// remove middle point from the list;
		for(i=j;i<n-1;i++)
			for(k=0;k<3;k++)
				c[i][k]=c[i+1][k];
		n--;

	} while (n>2);
}

///////////////

void CFemmviewView::PlotSelectedElm(CDC *pDC,CElement &elm)
{
	int i;
	POINT p[3];
	CFemmviewDoc *pDoc=GetDocument();

	if (elm.lbl!=DrawSelected)
		if (pDoc->blocklist[elm.lbl].IsSelected==FALSE) return;

	for(i=0;i<3;i++){
			p[i].x=pDoc->meshnode[elm.p[i]].xs;
			p[i].y=pDoc->meshnode[elm.p[i]].ys;
		}

	CPen FillPen,*pOldPen;
	CBrush FillBrush,*pOldBrush;
	if (pDoc->blocklist[elm.lbl].IsSelected==TRUE)
	{
		FillBrush.CreateSolidBrush(RegionColor);
		FillPen.CreatePen(PS_SOLID,1,RegionColor);
	}
	else{
		FillBrush.CreateSolidBrush(0x00ffffff);
		FillPen.CreatePen(PS_SOLID,1,0x00ffffff);
	}
	pOldBrush = pDC->SelectObject( &FillBrush );
	pOldPen = pDC->SelectObject( &FillPen );
	pDC->Polygon(p,3);	
	pDC->SelectObject(pOldPen);
	pDC->SelectObject(pOldBrush);
}

void CFemmviewView::DrawUserContour(BOOL flag)
{
	// FALSE == just draw last line in contour;
	// TRUE  == draw all lines in contour;
	int i,xs,ys,xso,yso;

	CFemmviewDoc *pDoc=GetDocument();
	CDC *pDC=GetDC();
	RECT r;
	GetClientRect(&r);

	for(i=0;i<pDoc->contour.GetSize();i++){
		DwgToScreen(pDoc->contour[i].re,pDoc->contour[i].im,&xs,&ys,&r);
		if((flag==TRUE) || (i==pDoc->contour.GetSize()-1))
		{
			if(i==0){
				SpecialLine(pDC,xs-2,ys,xs+2,ys,FALSE);
				SpecialLine(pDC,xs,ys-2,xs,ys+2,FALSE);
				xso=xs;yso=ys;
			}
			else{
				SpecialLine(pDC,xso,yso,xs,ys,FALSE);
				xso=xs; yso=ys;
			}
		}
		else{ xso=xs; yso=ys; }
	}
	ReleaseDC(pDC);
}

void CFemmviewView::EraseUserContour(BOOL flag)
{
	// FALSE == just draw last line in contour;
	// TRUE  == draw all lines in contour;
	int i,xs,ys,xso,yso;

	CFemmviewDoc *pDoc=GetDocument();
	CDC *pDC=GetDC();
	RECT r;
	GetClientRect(&r);

	for(i=0;i<pDoc->contour.GetSize();i++){
		DwgToScreen(pDoc->contour[i].re,pDoc->contour[i].im,&xs,&ys,&r);
		if((flag==TRUE) || (i==pDoc->contour.GetSize()-1))
		{
			if(i==0){
				SpecialLine(pDC,xs-2,ys,xs+2,ys,TRUE);
				SpecialLine(pDC,xs,ys-2,xs,ys+2,TRUE);
				xso=xs;yso=ys;
			}
			else{
				SpecialLine(pDC,xso,yso,xs,ys,TRUE);
				xso=xs; yso=ys;
			}
		}
		else{ xso=xs; yso=ys; }
	}
	ReleaseDC(pDC);
}

void CFemmviewView::OnDraw(CDC* pDC)
{
	CFemmviewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	RECT r;
	static RECT oldr;
	GetClientRect(&r);
	int i,j,k;				// usual iterators...
	int xs,ys,nx,ny;
	double xd,yd,dt,R;
	double xss,yss,rss,rt;
	CComplex p,c,s;
	
	const COLORREF mymap[12]={
		Color0,Color1,Color2,Color3,
		Color4,Color5,Color6,Color7,
		Color8,Color9,ColorA,ColorB};

	const COLORREF greymap[]=
		{Grey0,Grey1,Grey2,Grey3,
		 Grey4,Grey5,Grey6,Grey7,
		 Grey8,Grey9,GreyA,GreyB};
				
	if(pDoc->FirstDraw==TRUE){
		OnZoomNatural();
		LinePix.RemoveAll();
		oldr=r;
		char s[256];
		sprintf(s,"Title: %s",pDoc->GetTitle());
		Dspl->SetDlgItemText(IDC_LINE1,s);
		sprintf(s,"Frequency: %f Hz",pDoc->Frequency);
		Dspl->SetDlgItemText(IDC_LINE2,s);
		if(pDoc->ProblemType==TRUE)
			sprintf(s,"Axisymmetric Solution");
		else sprintf(s,"2-D Planar Solution");
		Dspl->SetDlgItemText(IDC_LINE3,s);
		switch(pDoc->LengthUnits){
			case 0:
				sprintf(s,"Length Units: Inches");
				break;
			case 1:
				sprintf(s,"Length Units: Millimeters");
				break;
			case 2:
				sprintf(s,"Length Units: Centimeters");
				break;
			case 4:
				sprintf(s,"Length Units: Mils");
				break;
			case 5:
				sprintf(s,"Length Units: Micrometers");
				break;
			default:
				sprintf(s,"Length Units: Meters");
				break;
		}
		Dspl->SetDlgItemText(IDC_LINE4,s);
		sprintf(s,"%i Nodes",pDoc->meshnode.GetSize());
		Dspl->SetDlgItemText(IDC_LINE6,s);
		sprintf(s,"%i Elements",pDoc->meshelem.GetSize());
		Dspl->SetDlgItemText(IDC_LINE7,s);
		sprintf(s,"");
		Dspl->SetDlgItemText(IDC_LINE0,s);
		Dspl->SetDlgItemText(IDC_LINE5,s);
		Dspl->SetDlgItemText(IDC_LINE8,s);
		Dspl->SetDlgItemText(IDC_LINE9,s);
		Dspl->SetDlgItemText(IDC_LINE10,s);
		Dspl->SetDlgItemText(IDC_LINE11,s);
	}

	if((oldr.right!=r.right) || (oldr.bottom!=r.bottom))
	{
		LinePix.RemoveAll();
		oldr=r;
	}

	if (pDC->IsPrinting()!=FALSE){
		CSize sz;
		RECT cr;
		int wd=pDC->GetDeviceCaps( HORZRES );
		int hd=pDC->GetDeviceCaps( VERTRES );
		int ww=r.right-r.left;
		int hw=r.bottom-r.top;
		int x=wd/ww;
		int y=hd/hw;
		if (y<x) x=y;
		pDC->SetMapMode(MM_ISOTROPIC);
		sz.cx=ww; sz.cy=hw;
		pDC->SetWindowExt(sz);
		sz.cx=x*ww; sz.cy=x*hw;
		pDC->SetViewportExt(sz);
		pDC->GetClipBox(&cr);
		pDC->IntersectClipRect(&r);
	}

	CPen *pOldPen;
	CPen penBlue,penRed,penBlack,penGreen,
		penMesh,penReal,penImag,penNode,penText;
	penBlue.CreatePen(PS_SOLID,1,LineColor);
	penRed.CreatePen(PS_SOLID,1,SelColor);
	penReal.CreatePen(PS_SOLID,1,RealFluxLineColor);
	penImag.CreatePen(PS_SOLID,1,ImagFluxLineColor);
	penGreen.CreatePen(PS_SOLID,1,BlockColor);
	penMesh.CreatePen(PS_SOLID,1,MeshColor);
	penNode.CreatePen(PS_SOLID,1,NodeColor);
	penText.CreatePen(PS_SOLID,1,TextColor);

	// Convert node coordinates to screen coordinates
	for(i=0;i<pDoc->nodelist.GetSize();i++)
	  if(DwgToScreen(pDoc->nodelist[i].x,pDoc->nodelist[i].y,
				  &(pDoc->nodelist[i].xs),&(pDoc->nodelist[i].ys),&r)==FALSE)
	{
		mag/=2.;
		i=-1;
	}
			
	// Convert meshnode coordinates to screen coordinates
	for(i=0;i<pDoc->meshnode.GetSize();i++)
	  DwgToScreen(pDoc->meshnode[i].x,pDoc->meshnode[i].y,
				  &(pDoc->meshnode[i].xs),&(pDoc->meshnode[i].ys),&r);
	
	// get center and radius of the screen in drawing coords.
	// can then use to find out whether elements are off the screen.
	xs=(r.right+r.left)/2;
	ys=(r.top+r.bottom)/2;
	ScreenToDwg(xs,ys, &xss, &yss, &r);
	rss=sqrt(pow((double)r.bottom,2.) + pow((double)r.right,2.))/(2.*mag);

	// Draw selected area...
	if (EditAction==2)
	{
		for(i=0;i<pDoc->meshelem.GetSize();i++){
			if((pDoc->meshelem[i].lbl==DrawSelected) || (DrawSelected==-1)){
				rt=sqrt( pow(xss-pDoc->meshelem[i].ctr.re,2.) +
				     pow(yss-pDoc->meshelem[i].ctr.im,2.) );
				if( rt < ( sqrt(pDoc->meshelem[i].rsqr) + rss) )
					PlotSelectedElm(pDC,pDoc->meshelem[i]);
			}
		}
	}

	// Draw flux densities if they are enabled...
	if(DensityPlot!=0){
		for(i=0;i<pDoc->meshelem.GetSize();i++){
			if((pDoc->meshelem[i].lbl==DrawSelected) || (DrawSelected==-1)){
				rt=abs(CComplex(xss,yss)-pDoc->meshelem[i].ctr);
				if( rt < ( sqrt(pDoc->meshelem[i].rsqr) + rss) )
				{
					PlotFluxDensity(pDC,pDoc->meshelem[i],DensityPlot);
				}
			}
		}
	}

	// Draw grid if it is enabled...
	if (GridFlag==TRUE)
	{
		int skip;
		BOOL drawgrid=TRUE;

		ScreenToDwg((int) r.right, (int) r.top, &xd, &yd, &r);
		nx=(int) (floor(xd/GridSize) - ceil(ox/GridSize));
		ny=(int) (floor(yd/GridSize) - ceil(oy/GridSize));
		
		if (nx>0){
			if((r.right/nx)<2) drawgrid=FALSE;
		}

		if (drawgrid==FALSE){
			StatBar->SetPaneText(0,"Grid too dense to display.",TRUE);
		}
		else{
			skip=__min((nx/20)+1,(ny/20)+1);
			skip=(int) pow(2.,floor(log((double) skip)/log(2.)));
			for(i=0,xd=GridSize*ceil(ox/GridSize);i<=nx;i++,xd+=GridSize)
				for(j=0,yd=GridSize*ceil(oy/GridSize);j<=ny;j++,yd+=GridSize)
				{
					if((i==skip*(i/skip)) || (j==skip*(j/skip)))
					{
						DwgToScreen(xd,yd,&xs,&ys,&r);
						pDC->SetPixel((int) xs, (int) ys, GridColor );
					}
				}
		}
	}

	// Draw mesh if it is enabled...
	if (MeshFlag==TRUE)
	{
		int pi,po;

		pOldPen = pDC->SelectObject( &penMesh );
		for(i=0;i<pDoc->meshelem.GetSize();i++)
		{
			if((pDoc->meshelem[i].lbl==DrawSelected) || (DrawSelected==-1)){
				for(j=0;j<3;j++)
				{
					k=j+1; if (k==3) k=0;
					pi=pDoc->meshelem[i].p[j];
					po=pDoc->meshelem[i].p[k];
					if(po>pi){
						pDC->MoveTo(pDoc->meshnode[pi].xs,
							pDoc->meshnode[pi].ys);
						pDC->LineTo(pDoc->meshnode[po].xs,
							pDoc->meshnode[po].ys);
					}
				}
			}
		}
		pDC->SelectObject( pOldPen );
	}

	// Draw contour lines, if they are enabled.
	pOldPen = pDC->SelectObject( &penReal );
	if (ShowAr==TRUE)
		for(i=0;i<pDoc->meshelem.GetSize();i++){
			if((pDoc->meshelem[i].lbl==DrawSelected) || (DrawSelected==-1)){
				rt=sqrt( pow(xss-pDoc->meshelem[i].ctr.re,2.) +
					     pow(yss-pDoc->meshelem[i].ctr.im,2.) );
				if( rt < ( sqrt(pDoc->meshelem[i].rsqr) + rss) )
					for(j=0;j<3;j++)
						DoContours(pDC,pDoc->meshelem[i].p,j,0);
			}
		}

	pDC->SelectObject(&penImag);
	if (ShowAi==TRUE)
		for(i=0;i<pDoc->meshelem.GetSize();i++){
			if((pDoc->meshelem[i].lbl==DrawSelected) || (DrawSelected==-1)){
				rt=sqrt( pow(xss-pDoc->meshelem[i].ctr.re,2.) +
					     pow(yss-pDoc->meshelem[i].ctr.im,2.) );
				if( rt < ( sqrt(pDoc->meshelem[i].rsqr) + rss) )
					for(j=0;j<3;j++)
						DoContours(pDC,pDoc->meshelem[i].p,j,1);
			}
		}
	pDC->SelectObject( pOldPen );

	// Draw lines linking nodes
	for(i=0;i<pDoc->linelist.GetSize();i++)
	if (pDoc->linelist[i].Hidden==FALSE){
		if(pDoc->linelist[i].IsSelected==FALSE)
			pOldPen = pDC->SelectObject( &penBlue );
		else pOldPen = pDC->SelectObject( &penRed );

		pDC->MoveTo(pDoc->nodelist[pDoc->linelist[i].n0].xs,
					pDoc->nodelist[pDoc->linelist[i].n0].ys);
		pDC->LineTo(pDoc->nodelist[pDoc->linelist[i].n1].xs,
					pDoc->nodelist[pDoc->linelist[i].n1].ys);
		
		pDC->SelectObject( pOldPen );
	}

	// Draw Arc Segments;
	for(i=0;i<pDoc->arclist.GetSize();i++)
	if (pDoc->arclist[i].Hidden==FALSE){
		if(pDoc->arclist[i].IsSelected==FALSE)
			pOldPen = pDC->SelectObject( &penBlue );
		else pOldPen = pDC->SelectObject( &penRed );
		k=(int) ceil(pDoc->arclist[i].ArcLength/pDoc->arclist[i].MaxSideLength);
		dt=pDoc->arclist[i].ArcLength*PI/(((double) k)*180.);

		pDoc->GetCircle(pDoc->arclist[i],c,R);
		p.Set(pDoc->nodelist[pDoc->arclist[i].n0].x,
			  pDoc->nodelist[pDoc->arclist[i].n0].y);
		DwgToScreen(p.re,p.im,&xs,&ys,&r);
		pDC->MoveTo(xs,ys);
		s=exp(I*dt);
		for(j=0;j<k;j++){
			p=(p-c)*s+c;
			DwgToScreen(p.re,p.im,&xs,&ys,&r);
			pDC->LineTo(xs,ys);
		}
		pDC->SelectObject( pOldPen );
	}

	// Draw node points
	if(PtsFlag==TRUE) for(i=0;i<pDoc->nodelist.GetSize();i++)
	{
		xs=pDoc->nodelist[i].xs;
		ys=pDoc->nodelist[i].ys;

		if(pDoc->nodelist[i].IsSelected==FALSE)
			pOldPen = pDC->SelectObject( &penNode );
		else pOldPen = pDC->SelectObject( &penRed );

		pDC->MoveTo(xs-2,ys-2);
		pDC->LineTo(xs-2,ys+2);
		pDC->LineTo(xs+2,ys+2);
		pDC->LineTo(xs+2,ys-2);
		pDC->LineTo(xs-2,ys-2);

		pDC->SelectObject( pOldPen );
	}

	if(EditAction==1) DrawUserContour(TRUE);

	// Draw Legend if it is enabled;
	if((LegendFlag==TRUE) && (DensityPlot!=0))
	{
		CBrush *pOldBrush;
		char cc[80];		
		double dta;
		CBrush BackBrush;
	
		pOldPen = pDC->SelectObject( &penText );
		pDC->SetTextColor(TextColor);
		pDC->SetBkMode(TRANSPARENT);
  
		BackBrush.CreateSolidBrush(BackColor);
		pOldBrush = pDC->SelectObject( &BackBrush );
		pDC->Rectangle(r.right-212-6,r.top+6,r.right-6,r.top+24+13*16 );
		pDC->SelectObject(pOldBrush);

		if (DensityPlot==1) sprintf(cc,"Density Plot: |B|, Tesla");
		if (DensityPlot==2) sprintf(cc,"Density Plot: |B_re|, Tesla");
		if (DensityPlot==3) sprintf(cc,"Density Plot: |B_im|, Tesla");
		pDC->TextOut(r.right-212,r.top+16*12+16,cc,strlen(cc));

		dta=(pDoc->B_ub - pDoc->B_lb)/12.;

		for(i=0;i<12;i++){
			
			{		
				CBrush FillBrush;

				if (GreyContours==FALSE) FillBrush.CreateSolidBrush(mymap[i]);
				else FillBrush.CreateSolidBrush(greymap[i]);
				pOldBrush = pDC->SelectObject( &FillBrush );
				pDC->Rectangle(r.right-212,r.top+16*i+12,r.right-187,r.top+12+16*(i+1) );
				pDC->SelectObject(pOldBrush);
			}
			
			if(i==0) sprintf(cc,">%.3e",pDoc->B_ub - dta);
			else if(i==11) sprintf(cc,"<%.3e",pDoc->B_lb + dta);
			else sprintf(cc,"%.3e : %.3e",((double) (11-i))*dta + pDoc->B_lb,
				((double) (12-i))*dta + pDoc->B_lb);
			pDC->TextOut(r.right-182,r.top+16*i+12,cc,strlen(cc));
		}
		pDC->SelectObject( pOldPen );
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView printing

BOOL CFemmviewView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CFemmviewView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CFemmviewView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView diagnostics

#ifdef _DEBUG
void CFemmviewView::AssertValid() const
{
	CView::AssertValid();
}

void CFemmviewView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFemmviewDoc* CFemmviewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFemmviewDoc)));
	return (CFemmviewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFemmviewView message handlers

void CFemmviewView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	static char statmsg[256];
	double x,y,q;
	RECT r;
	CFemmviewDoc *pDoc=GetDocument();

	// get size of current client area and convert mouse position into
	// position on the actual drawing.
	GetClientRect(&r);
	q=pow(10.,floor(log(mag)/log(10.)+0.5));
	x=(double) point.x; y=(double) (r.bottom-point.y-1);
	x=x/mag+ox; y=y/mag+oy;
	x=floor(x*q+0.5)/q; y=floor(y*q+0.5)/q;

	// process Snap to Grid command
	if ((SnapFlag==TRUE) && (EditAction!=2) && (ZoomWndFlag==0)){
		x=GridSize*floor(0.5+x/GridSize);
		y=GridSize*floor(0.5+y/GridSize);
	}

	// draw box for window zoom;
	if(ZoomWndFlag==2){
		CDC *pDC=GetDC();
		COLORREF ocol;
		CZPix p;

		int xso,yso,xsi,ysi,xsn,ysn,i,k,lo,hi;
		DwgToScreen(wzx,wzy,&xso,&yso,&r);
		DwgToScreen(mx,my,&xsi,&ysi,&r);
		DwgToScreen(x,y,&xsn,&ysn,&r);

		// Draw old rectangle off the screen;
		if(ZoomPix.GetSize()>0){
			for(k=ZoomPix.GetSize()-1;k>=0;k--)
				pDC->SetPixel(ZoomPix[k].x,ZoomPix[k].y,ZoomPix[k].c);
			ZoomPix.RemoveAll();
		}

		// XOR new rectangle onto screen
		if(xso<xsn){ lo=xso,hi=xsn; }
		else{ lo=xsn; hi=xso; }
		for(i=lo;i<=hi;i++){
			ocol=pDC->GetPixel(i,ysn);
			p.c=ocol; p.x=i; p.y=ysn;
			ZoomPix.Add(p);
			ocol=ocol ^ RGB(255,255,255);
			pDC->SetPixel(i,ysn,ocol);
			ocol=pDC->GetPixel(i,yso);
			p.c=ocol; p.x=i; p.y=yso;
			ZoomPix.Add(p);
			ocol=ocol ^ RGB(255,255,255);
			pDC->SetPixel(i,yso,ocol);
		}
		if(yso<ysn){ lo=yso,hi=ysn; }
		else{ lo=ysn; hi=yso; }
		for(i=lo;i<=hi;i++){
			ocol=pDC->GetPixel(xso,i);
			p.c=ocol; p.x=xso; p.y=i;
			ZoomPix.Add(p);
			ocol=ocol ^ RGB(255,255,255);
			pDC->SetPixel(xso,i,ocol);
			ocol=pDC->GetPixel(xsn,i);
			p.c=ocol; p.x=xsn; p.y=i;
			ZoomPix.Add(p);
			ocol=ocol ^ RGB(255,255,255);
			pDC->SetPixel(xsn,i,ocol);
		}

		ReleaseDC(pDC);
	}
	

	// update mouse position;
	mx=x; my=y;

	if ((pDoc->Coords==FALSE) && (pDoc->ProblemType==0))
		sprintf(statmsg,"(x=%.4f,y=%.4f)",x,y);
	else if ((pDoc->Coords==FALSE) && (pDoc->ProblemType==1))
		sprintf(statmsg,"(r=%.4f,z=%.4f)",x,y);
	else sprintf(statmsg,"(%.4f at %.4f deg)",sqrt(x*x+y*y),atan2(y,x)*180/PI);
	StatBar->SetPaneText(0,statmsg,TRUE);

	CView::OnMouseMove(nFlags, point);
}

void CFemmviewView::OnZoomIn() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;

	ox=ox+0.25*x/mag;
	oy=oy+0.25*y/mag;
	mag*=2.;

	RedrawView();
}

void CFemmviewView::OnZoomOut() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;
	ox=ox-0.5*x/mag;
	oy=oy-0.5*y/mag;
	mag/=2.;

	RedrawView();
}

void CFemmviewView::OnZoomNatural() 
{
	CFemmviewDoc *pDoc=GetDocument();
	double x[2],y[2],m[2],w;
	RECT r;
	int i;

	if (pDoc->meshnode.GetSize()<2) return;
	x[0]=pDoc->meshnode[0].x;	x[1]=pDoc->meshnode[0].x;
	y[0]=pDoc->meshnode[0].y;	y[1]=pDoc->meshnode[0].y;
	for(i=1;i<pDoc->meshnode.GetSize();i++)
	{
		if(pDoc->meshnode[i].x<x[0]) x[0]=pDoc->meshnode[i].x;
		if(pDoc->meshnode[i].x>x[1]) x[1]=pDoc->meshnode[i].x;
		if(pDoc->meshnode[i].y<y[0]) y[0]=pDoc->meshnode[i].y;
		if(pDoc->meshnode[i].y>y[1]) y[1]=pDoc->meshnode[i].y;
	}

	if(pDoc->FirstDraw==TRUE){
		if((x[1]-x[0])>(y[1]-y[0])) w=x[1]-x[0];
		else w=y[1]-y[0];
		if(w!=0)
			GridSize=pow(10.,floor(log(w)/log(10.)-0.5));
	}

	ox=x[0]; oy=y[0];
	GetClientRect(&r);
	m[0]=((double) (r.right-1))/(x[1]-x[0]);
	m[1]=((double) (r.bottom-1))/(y[1]-y[0]);

	if(m[0]<m[1]) mag=m[0];
	else mag=m[1];
	
	if(pDoc->FirstDraw==TRUE) pDoc->FirstDraw=FALSE;
	else RedrawView();	
}


void CFemmviewView::OnKbdZoom() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();
	CKbdZoom dlg;
	RECT r;
	double m[2],x[4],z;

	GetClientRect(&r);
	ScreenToDwg(r.right,r.top, &dlg.m_scr_right, &dlg.m_scr_top, &r);
	dlg.m_scr_top=floor(1000.*dlg.m_scr_top)/1000.;
	dlg.m_scr_right=floor(1000.*dlg.m_scr_right)/1000.;
	dlg.m_scr_bottom=oy;
	dlg.m_scr_left=ox;

	if(dlg.DoModal()==IDOK)
	{
		x[0]=dlg.m_scr_left;
		x[1]=dlg.m_scr_bottom;
		x[2]=dlg.m_scr_right;
		x[3]=dlg.m_scr_top;
		
		if(x[0]>x[2]){ z=x[2]; x[2]=x[0]; x[0]=z; }
		if(x[1]>x[3]){ z=x[3]; x[3]=x[1]; x[1]=z; }

		ox=x[0]; oy=x[1]; 
		m[0]=((double) (r.right-1))/(x[2]-x[0]);
		m[1]=((double) (r.bottom-1))/(x[3]-x[1]);
		if(m[0]<m[1]) mag=m[0];
		else mag=m[1];
		RedrawView();
	}
}

void CFemmviewView::OnZoomWindow() 
{
	// TODO: Add your command handler code here
	ZoomWndFlag=TRUE;	
	ZoomPix.RemoveAll();
}

void CFemmviewView::OnShowGrid() 
{
	// TODO: Add your command handler code here

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	if(GridFlag==TRUE){
		GridFlag=FALSE;
		MMnu->CheckMenuItem(ID_SHOW_GRID, MF_UNCHECKED);
		tc->CheckButton(ID_SHOW_GRID,FALSE);
	}
	else{
		GridFlag=TRUE;
		MMnu->CheckMenuItem(ID_SHOW_GRID, MF_CHECKED);
		tc->CheckButton(ID_SHOW_GRID,TRUE);
	}
	RedrawView();
}

void CFemmviewView::OnSetGrid() 
{
	// TODO: Add your command handler code here
	CGridMod pDlg;
	CFemmviewDoc *pDoc=GetDocument();
	
	// Send present parameter values to the dialog
	// pDlg.m_rji=TheDoc->vi[0];
	pDlg.m_gridsize       = GridSize;
	pDlg.coords			  = pDoc->Coords;
	
	// Display dialog and collect data
	if(pDlg.DoModal()==IDOK)
	{
		GridSize=pDlg.m_gridsize;
		pDoc->Coords=pDlg.coords;
		RedrawView();
	}
}

void CFemmviewView::OnSnapGrid() 
{
	// TODO: Add your command handler code here
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();

	if(SnapFlag==TRUE){
		SnapFlag=FALSE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_UNCHECKED);
		tc->CheckButton(ID_SNAP_GRID,FALSE);
	}
	else{
		SnapFlag=TRUE;
		MMnu->CheckMenuItem(ID_SNAP_GRID, MF_CHECKED);
		tc->CheckButton(ID_SNAP_GRID,TRUE);
	}
}

void CFemmviewView::OnShowMesh() 
{
	// TODO: Add your command handler code here
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	if(MeshFlag==TRUE){
		MeshFlag=FALSE;
		MMnu->CheckMenuItem(ID_SHOW_MESH, MF_UNCHECKED);
		tc->CheckButton(ID_SHOW_MESH,FALSE);
	}
	else{
		MeshFlag=TRUE;
		MMnu->CheckMenuItem(ID_SHOW_MESH, MF_CHECKED);
		tc->CheckButton(ID_SHOW_MESH,TRUE);
	}

	RedrawView();
}


void CFemmviewView::OnCplot() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();

	if(pDoc->Frequency>0){
		CCPlotDlg dlg;
		dlg.m_showar=ShowAr;
		dlg.m_showai=ShowAi;
		dlg.m_numcontours=NumContours;
		dlg.m_alow=pDoc->A_Low;
		dlg.m_ahigh=pDoc->A_High;
		dlg.Alb=pDoc->A_lb;
		dlg.Aub=pDoc->A_ub;
		if(dlg.DoModal()==IDOK){
			ShowAr=dlg.m_showar;
			ShowAi=dlg.m_showai;
			pDoc->A_Low=dlg.m_alow;
			pDoc->A_High=dlg.m_ahigh;
			NumContours=dlg.m_numcontours;
			RedrawView();
		}
	}
	else{
		CCplotDlg2 dlg;
		dlg.m_showa=ShowAr;
		dlg.m_numcontours=NumContours;
		dlg.m_alow=pDoc->A_Low;
		dlg.m_ahigh=pDoc->A_High;
		dlg.Alb=pDoc->A_lb;
		dlg.Aub=pDoc->A_ub;
		if(dlg.DoModal()==IDOK){
			ShowAr=dlg.m_showa;
			ShowAi=FALSE;
			pDoc->A_Low=dlg.m_alow;
			pDoc->A_High=dlg.m_ahigh;
			NumContours=dlg.m_numcontours;
			RedrawView();
		}
	}
}

void CFemmviewView::OnDplot() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();

	if (pDoc->Frequency>0){
		CDPlotDlg1 dlg;
		dlg.btnState=DensityPlot;
		dlg.m_showlegend=LegendFlag;
		dlg.m_gscale=GreyContours;

		dlg.Bm_l=pDoc->B_Low;
		dlg.Bm_h=pDoc->B_High;
		
		dlg.Br_l=pDoc->Br_Low;
		dlg.Br_h=pDoc->Br_High;
		
		dlg.Bi_l=pDoc->Bi_Low;
		dlg.Bi_h=pDoc->Bi_High;

		dlg.m_lb1=pDoc->B_lb;
		dlg.m_ub1=pDoc->B_ub;

		if(dlg.DoModal()==IDOK){
			DensityPlot=dlg.btnState;
			LegendFlag=dlg.m_showlegend;
			GreyContours=dlg.m_gscale;
			RedrawView();
			pDoc->B_ub=dlg.m_ub1;
			pDoc->B_lb=dlg.m_lb1;
		}
	}
	else{
		CDPlotDlg2 dlg;
		if(DensityPlot>0) DensityPlot=1;
		dlg.m_showit=DensityPlot;
		dlg.m_showlegend=LegendFlag;
		dlg.m_gscale=GreyContours;
		dlg.Bm_h=pDoc->B_High;
		dlg.Bm_l=pDoc->B_Low;
		dlg.m_ub2=pDoc->B_ub;
		dlg.m_lb2=pDoc->B_lb;

		if(dlg.DoModal()==IDOK){
			DensityPlot=dlg.m_showit;
			LegendFlag=dlg.m_showlegend;
			GreyContours=dlg.m_gscale;
			pDoc->B_ub=dlg.m_ub2;
			pDoc->B_lb=dlg.m_lb2;
			RedrawView();
		}
	}
}

void CFemmviewView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	if (MFrm==NULL) AfxMessageBox("Null GetParentFrame");
	else{
		StatBar=(CStatusBar *)MFrm->GetMessageBar();
		Dspl=&MFrm->m_dlgBar;
	/*	char s[80];
		sprintf(s,"Femmview version 3.0");
		Dspl->SetDlgItemText(IDC_LINE1,s);
		sprintf(s,"Magnetics finite element postprocessor");
		Dspl->SetDlgItemText(IDC_LINE2,s);
		sprintf(s,"Copyright 1998-2000");
		Dspl->SetDlgItemText(IDC_LINE4,s);
		sprintf(s,"David Meeker");
		Dspl->SetDlgItemText(IDC_LINE5,s);
		sprintf(s,"dcm3c@aol.com");
		Dspl->SetDlgItemText(IDC_LINE6,s);
		sprintf(s,"http://members.aol.com/dcm3c");
		Dspl->SetDlgItemText(IDC_LINE7,s);
		sprintf(s," ");
		Dspl->SetDlgItemText(IDC_LINE8,s);
		sprintf(s," ");
		Dspl->SetDlgItemText(IDC_LINE9,s);
		sprintf(s," ");
		Dspl->SetDlgItemText(IDC_LINE10,s);	*/
	}

	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	tc->CheckButton(ID_MENU_AREA, FALSE);
	tc->CheckButton(ID_MENU_CONTOUR, FALSE);
	tc->CheckButton(ID_MENU_POINT, TRUE);
	EditAction=0;
}

void CFemmviewView::DisplayPointProperties(double px, double py)
{
	CFemmviewDoc* pDoc = GetDocument();
	CPointVals u;
	CComplex Jtot;

	if(pDoc->GetPointValues(px, py, u)==TRUE)
	{
		char s[80],c[80];
		if (pDoc->ProblemType>=0)
		{
			if(pDoc->Frequency==0)
			{
				if (pDoc->ProblemType==0)
				{
					sprintf(s,"Point: x=%8.4f, y=%8.4f",px,py);
					Dspl->SetDlgItemText(IDC_LINE0,s);
					sprintf(s,"A   = %.3e Weber/m",u.A.re);
					Dspl->SetDlgItemText(IDC_LINE1,s);
					sprintf(s,"|B| = %.3e Tesla",sqrt(u.B1.re*u.B1.re + u.B2.re*u.B2.re));
					Dspl->SetDlgItemText(IDC_LINE2,s);
					sprintf(s,"Bx  = %.3e Tesla",u.B1.re);
					Dspl->SetDlgItemText(IDC_LINE3,s);
					sprintf(s,"By  = %.3e Tesla",u.B2.re);
					Dspl->SetDlgItemText(IDC_LINE4,s);
					sprintf(s,"|H| = %.3e Amp/m",sqrt(u.H1.re*u.H1.re + u.H2.re*u.H2.re));
					Dspl->SetDlgItemText(IDC_LINE5,s);
					sprintf(s,"Hx  = %.3e Amp/m",u.H1.re);
					Dspl->SetDlgItemText(IDC_LINE6,s);
					sprintf(s,"Hy  = %.3e Amp/m",u.H2.re);
					Dspl->SetDlgItemText(IDC_LINE7,s);
					sprintf(s,"mu_x= %.3e (relative)",u.mu1.re);
					Dspl->SetDlgItemText(IDC_LINE8,s);
					sprintf(s,"mu_y = %.3e (relative)",u.mu2.re);
					Dspl->SetDlgItemText(IDC_LINE9,s);
					sprintf(s,"E   = %.3e Joules/m^3",u.E);
					Dspl->SetDlgItemText(IDC_LINE10,s);
					sprintf(s,"J   = %.3e MA/m^2",u.Js.re);
					Dspl->SetDlgItemText(IDC_LINE11,s);
				}
				else{
					sprintf(s,"Point: r=%8.4f, z=%8.4f",px,py);
					Dspl->SetDlgItemText(IDC_LINE0,s);
					sprintf(s,"Flux= %.3e Webers",u.A.re);
					Dspl->SetDlgItemText(IDC_LINE1,s);
					sprintf(s,"|B| = %.3e Tesla",sqrt(u.B1.re*u.B1.re + u.B2.re*u.B2.re));
					Dspl->SetDlgItemText(IDC_LINE2,s);
					sprintf(s,"Br  = %.3e Tesla",u.B1.re);
					Dspl->SetDlgItemText(IDC_LINE3,s);
					sprintf(s,"Bz  = %.3e Tesla",u.B2.re);
					Dspl->SetDlgItemText(IDC_LINE4,s);
					sprintf(s,"|H| = %.3e Amp/m",sqrt(u.H1.re*u.H1.re + u.H2.re*u.H2.re));
					Dspl->SetDlgItemText(IDC_LINE5,s);
					sprintf(s,"Hr  = %.3e Amp/m",u.H1.re);
					Dspl->SetDlgItemText(IDC_LINE6,s);
					sprintf(s,"Hz  = %.3e Amp/m",u.H2.re);
					Dspl->SetDlgItemText(IDC_LINE7,s);
					sprintf(s,"mu_r= %.3e (relative)",u.mu1.re);
					Dspl->SetDlgItemText(IDC_LINE8,s);
					sprintf(s,"mu_z= %.3e (relative)",u.mu2.re);
					Dspl->SetDlgItemText(IDC_LINE9,s);
					sprintf(s,"P   = %.3e Joules/m^3",u.E);
					Dspl->SetDlgItemText(IDC_LINE10,s);
					sprintf(s,"J   = %.3e MA/m^2",u.Js.re);
					Dspl->SetDlgItemText(IDC_LINE11,s);
				}
			}
			// Harmonic problems...
			else{
				if(pDoc->ProblemType==0){
					sprintf(s,"Point: x=%8.4f, y=%8.4f",px,py);
					Dspl->SetDlgItemText(IDC_LINE0,s);
					sprintf(s,"A   = %s Weber/m",u.A.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE1,s);
					sprintf(s,"|B| = %.3e Tesla",sqrt(u.B1.re*u.B1.re + u.B2.re*u.B2.re
						+u.B1.im*u.B1.im + u.B2.im*u.B2.im));
					Dspl->SetDlgItemText(IDC_LINE2,s);
					sprintf(s,"Bx  = %s Tesla",u.B1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE3,s);
					sprintf(s,"By  = %s Tesla",u.B2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE4,s);
					sprintf(s,"|H| = %.3e Amp/m",sqrt(u.H1.re*u.H1.re + u.H2.re*u.H2.re
						+u.H1.im*u.H1.im + u.B2.im*u.H2.im));
					Dspl->SetDlgItemText(IDC_LINE5,s);
					sprintf(s,"Hx  = %s Amp/m",u.H1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE6,s);
					sprintf(s,"Hy  = %s Amp/m",u.H2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE7,s);
					sprintf(s,"mu_x= %s (relative)",u.mu1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE8,s);
					sprintf(s,"mu_y= %s (relative)",u.mu2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE9,s);
					Jtot=u.Je + u.Js;
					sprintf(s,"J= %s MA/m^2",Jtot.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE10,s);
					sprintf(s,"");
					Dspl->SetDlgItemText(IDC_LINE11,s);
				}
				if(pDoc->ProblemType==1){
					sprintf(s,"Point: r=%8.4f, z=%8.4f",px,py);
					Dspl->SetDlgItemText(IDC_LINE0,s);
					sprintf(s,"Flux= %s Wb",u.A.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE1,s);
					sprintf(s,"|B| = %.3e Tesla",sqrt(u.B1.re*u.B1.re + u.B2.re*u.B2.re
						+u.B1.im*u.B1.im + u.B2.im*u.B2.im));
					Dspl->SetDlgItemText(IDC_LINE2,s);
					sprintf(s,"Br  = %s Tesla",u.B1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE3,s);
					sprintf(s,"Bz  = %s Tesla",u.B2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE4,s);
					sprintf(s,"|H| = %.3e Amp/m",sqrt(u.H1.re*u.H1.re + u.H2.re*u.H2.re
						+u.H1.im*u.H1.im + u.B2.im*u.H2.im));
					Dspl->SetDlgItemText(IDC_LINE5,s);
					sprintf(s,"Hr  = %s Amp/m",u.H1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE6,s);
					sprintf(s,"Hz  = %s Amp/m",u.H2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE7,s);
					sprintf(s,"mu_r %s (relative)",u.mu1.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE8,s);
					sprintf(s,"mu_z= %s (relative)",u.mu2.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE9,s);
					Jtot=u.Je + u.Js;
					sprintf(s,"J= %s MA/m^2",Jtot.ToString(c));
					Dspl->SetDlgItemText(IDC_LINE10,s);
					sprintf(s,"");
					Dspl->SetDlgItemText(IDC_LINE11,s);
				}
			}
		}
}
}

void CFemmviewView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		
	int i,j,k,m;

	if (ZoomWndFlag==1)
	{
		ZoomWndFlag++;
		wzx=mx;wzy=my;
		return;
	}

	if (ZoomWndFlag==2) return;
		
	if (EditAction==0) DisplayPointProperties(mx,my);

	if (EditAction==1){
		CFemmviewDoc *pDoc=GetDocument();
		if (pDoc->nodelist.GetSize()>0){
			i=pDoc->ClosestNode(mx,my);
			CComplex x,y,z;
			double R,d1,d2;
			int lineno,arcno,flag=0;
			z.Set(pDoc->nodelist[i].x,pDoc->nodelist[i].y);

			if (pDoc->contour.GetSize()>0){
				
				//check to see if point is the same as last point in the contour;
				y=pDoc->contour[pDoc->contour.GetSize()-1];
				if ((y.re==z.re) && (y.im==z.im)) return;
				
				j=pDoc->ClosestNode(y.re,y.im);
				x.Set(pDoc->nodelist[j].x,pDoc->nodelist[j].y);

				//check to see if this point and the last point are ends of an
				//input segment;
				lineno=-1;
				d1=1.e08;
								
				if (abs(x-y)<1.e-08){
					for(k=0;k<pDoc->linelist.GetSize();k++){
						if((pDoc->linelist[k].n0==j) && (pDoc->linelist[k].n1==i))
						{
							d2=fabs(pDoc->ShortestDistanceFromSegment(mx,my,k));
							if(d2<d1){
								lineno=k;
								d1=d2;
							}
						}
						if((pDoc->linelist[k].n0==i) && (pDoc->linelist[k].n1==j))
						{
							d2=fabs(pDoc->ShortestDistanceFromSegment(mx,my,k));
							if(d2<d1){
								lineno=k;
								d1=d2;
							}
						}
					}
				}

				//check to see if this point and last point are ends of an
				// arc segment; if so, add entire arc to the contour;
				arcno=-1;
				if (abs(x-y)<1.e-08){
					for(k=0;k<pDoc->arclist.GetSize();k++){
						if((pDoc->arclist[k].n0==j) && (pDoc->arclist[k].n1==i))
						{
							d2=pDoc->ShortestDistanceFromArc(CComplex(mx,my),
							   pDoc->arclist[k]);
							if(d2<d1){
								arcno=k;
								lineno=-1;
								flag=TRUE;
								d1=d2;
							}
						}
						if((pDoc->arclist[k].n0==i) && (pDoc->arclist[k].n1==j))
						{
							d2=pDoc->ShortestDistanceFromArc(CComplex(mx,my),
							   pDoc->arclist[k]);
							if(d2<d1){
								arcno=k;
								lineno=-1;
								flag=FALSE;
								d1=d2;
							}
						}
					}
				}
				
			}
			else{
				pDoc->contour.Add(z);
				DrawUserContour(FALSE);
				return;
			}

			if((lineno<0) && (arcno<0)){
				pDoc->contour.Add(z);
				DrawUserContour(FALSE);
			}

			if(lineno>=0){
				j=pDoc->contour.GetSize();
				if(j>1){
					if(abs(pDoc->contour[j-2]-z)<1.e-08){
						CView::OnLButtonDown(nFlags, point);
						return;
					}
				}
				pDoc->contour.Add(z);
				DrawUserContour(FALSE);
			}
			if(arcno>=0){
				k=arcno;
				pDoc->GetCircle(pDoc->arclist[k],x,R);
				j=(int) ceil(pDoc->arclist[k].ArcLength/pDoc->arclist[k].MaxSideLength);
				if(flag==TRUE)
					z=exp(I*pDoc->arclist[k].ArcLength*PI/(180.*((double) j)) );
				else
					z=exp(-I*pDoc->arclist[k].ArcLength*PI/(180.*((double) j)) );
				for(i=0;i<j;i++){
					y=(y-x)*z+x;
					m=pDoc->contour.GetSize();
					if(m>1){
						if(abs(pDoc->contour[m-2]-y)<1.e-08){
							CView::OnLButtonDown(nFlags, point);
							return;
						}
					}
					pDoc->contour.Add(y);
					DrawUserContour(FALSE);
				}
			}
		}
	}

	if (EditAction==2){
		CFemmviewDoc *pDoc=GetDocument();

		if (pDoc->meshelem.GetSize()>0){
			k=pDoc->InTriangle(mx,my);
			if(k>=0){
				pDoc->blocklist[pDoc->meshelem[k].lbl].ToggleSelect();
			//	RedrawView();
				DrawSelected=pDoc->meshelem[k].lbl;
				CDC *pDC=GetDC();
				OnDraw(pDC);
				DrawSelected=-1;
				ReleaseDC(pDC);
			}
		}
			
	}
	
	CView::OnLButtonDown(nFlags, point);
}

void CFemmviewView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	if (ZoomWndFlag>0){
		ZoomPix.RemoveAll();
		ZoomWndFlag=0;
		if((mx==wzx) && (my==wzy)){
			RedrawView();
			return;
		}
		RECT r;
		double z,cmag,m[2];
		if (mx<wzx){ z=wzx; wzx=mx; mx=z; }
		if (my<wzy){ z=wzy; wzy=my; my=z; }
		GetClientRect(&r);
		m[0]=((double) r.right)/(mx-wzx);
		m[1]=((double) r.bottom)/(my-wzy);


		if(m[0]<m[1]) cmag=m[0];
		else cmag=m[1];
		
		mag=cmag;
		ox=wzx; oy=wzy;
		
		RedrawView();
	}

	CView::OnLButtonUp(nFlags, point);
}

void CFemmviewView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
		
	if (EditAction==1){
		CComplex z;
		int i;
		CFemmviewDoc *pDoc=GetDocument();
		z.Set(mx,my);
		i=pDoc->contour.GetSize();
		if(i>0){
			if (z!=pDoc->contour[i-1])
				pDoc->contour.Add(z);
		}
		else pDoc->contour.Add(z);
		DrawUserContour(FALSE);
	}
	
	CView::OnRButtonDown(nFlags, point);
}

void CFemmviewView::OnEditCopy() 
{
	// TODO: Add your command handler code here
	CMetaFileDC Meta;
	RECT r;
	CRgn R;

	Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
	GetClientRect(&r);
	R.CreateRectRgnIndirect(&r);
	Meta.SelectClipRgn(&R);
	OnDraw(&Meta);
	HENHMETAFILE hMeta=Meta.CloseEnhanced();
	if (hMeta==NULL) AfxMessageBox("No Handle...");
	if (OpenClipboard()==FALSE)
		AfxMessageBox("Cannot access the Clipboard");
	else{
		EmptyClipboard();
		if(SetClipboardData(CF_ENHMETAFILE,hMeta)==NULL)
		{
			AfxMessageBox("Couldn't SetClipboardData");
		}
		CloseClipboard();
	}
}

void CFemmviewView::OnReload() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();
	BeginWaitCursor();
	pDoc->OnReload();
	EndWaitCursor();
	RedrawView();
}



void CFemmviewView::OnMenuArea() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();
	if(EditAction==1){
		EraseUserContour(TRUE);
		pDoc->contour.RemoveAll();
	}
	EditAction=2;

	// update check boxes in the main menu...
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	MMnu->CheckMenuItem(ID_MENU_AREA, MF_CHECKED);
	MMnu->CheckMenuItem(ID_MENU_CONTOUR, MF_UNCHECKED);
	MMnu->CheckMenuItem(ID_MENU_POINT, MF_UNCHECKED);
	tc->CheckButton(ID_MENU_AREA, TRUE);
	tc->CheckButton(ID_MENU_CONTOUR, FALSE);
	tc->CheckButton(ID_MENU_POINT, FALSE);
}

void CFemmviewView::OnMenushowpts() 
{
	// TODO: Add your command handler code here

	CFrameWnd *MFrm;
	MFrm=GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();

	if(PtsFlag==FALSE){
		PtsFlag=TRUE;
		MMnu->CheckMenuItem(ID_MENUSHOWPTS, MF_CHECKED);
	}
	else{
		PtsFlag=FALSE;
		MMnu->CheckMenuItem(ID_MENUSHOWPTS, MF_UNCHECKED);
	}
	RedrawView();
}

void CFemmviewView::OnMenuContour() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();

	if(EditAction==2){
		int i;
		BOOL flg=FALSE;
		for(i=0;i<pDoc->blocklist.GetSize();i++){
			if (pDoc->blocklist[i].IsSelected==TRUE){
				pDoc->blocklist[i].IsSelected=FALSE;
				flg=TRUE;
			}
		}
		
		if(flg==TRUE) RedrawView();
	}

	EditAction=1;
	

	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	MMnu->CheckMenuItem(ID_MENU_AREA, MF_UNCHECKED);
	MMnu->CheckMenuItem(ID_MENU_CONTOUR, MF_CHECKED);
	MMnu->CheckMenuItem(ID_MENU_POINT, MF_UNCHECKED);
	tc->CheckButton(ID_MENU_AREA, FALSE);
	tc->CheckButton(ID_MENU_CONTOUR, TRUE);
	tc->CheckButton(ID_MENU_POINT, FALSE);
}

void CFemmviewView::OnMenuPoint() 
{
	CFemmviewDoc *pDoc=GetDocument();
	// TODO: Add your command handler code here
	if (EditAction==1){
		EraseUserContour(TRUE);
		pDoc->contour.RemoveAll();
	}
	if (EditAction==2){
		int i;
		BOOL flg=FALSE;
		for(i=0;i<pDoc->blocklist.GetSize();i++){
			if (pDoc->blocklist[i].IsSelected==TRUE){
				pDoc->blocklist[i].IsSelected=FALSE;
				flg=TRUE;
			}
		}
		
		if(flg==TRUE) RedrawView();
	}
	
	EditAction=0;

	// update check boxes in the main menu...
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	CToolBar *pToolBar;
	pToolBar=&MFrm->m_toolBar;    
	CToolBarCtrl *tc=&pToolBar->GetToolBarCtrl();
	
	MMnu->CheckMenuItem(ID_MENU_AREA, MF_UNCHECKED);
	MMnu->CheckMenuItem(ID_MENU_CONTOUR, MF_UNCHECKED);
	MMnu->CheckMenuItem(ID_MENU_POINT, MF_CHECKED);
	tc->CheckButton(ID_MENU_AREA, FALSE);
	tc->CheckButton(ID_MENU_CONTOUR, FALSE);
	tc->CheckButton(ID_MENU_POINT, TRUE);
	
}

void CFemmviewView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	CFemmviewDoc *pDoc=GetDocument();

	if (nChar==VK_LEFT)  OnPanLeft();
	if (nChar==VK_RIGHT) OnPanRight();
	if (nChar==VK_UP)    OnPanUp();   
	if (nChar==VK_DOWN)  OnPanDown();
	if (nChar==VK_PRIOR) OnZoomIn();	// page up
	if (nChar==VK_NEXT)  OnZoomOut();	// page down
	if (nChar==VK_HOME)  OnZoomNatural();

	if ((nChar==VK_TAB) && (EditAction!=2))	EnterPoint();

	if ((nChar==VK_DELETE) && (EditAction==1)){
		int k;
		k=pDoc->contour.GetSize();

		if(k>1){
			EraseUserContour(FALSE);
			pDoc->contour.RemoveAt(k-1);
			DrawUserContour(TRUE);
		} 
		else if(k!=0){
			EraseUserContour(TRUE);
			pDoc->contour.RemoveAt(0);
		}
	}

	if ((nChar==VK_ESCAPE) && (EditAction==1)){
		EraseUserContour(TRUE);
		pDoc->contour.RemoveAll();
	}

	if ((nChar==VK_ESCAPE) && (EditAction==2)){
		BOOL flg=FALSE;
		int i;
		
		for(i=0;i<pDoc->blocklist.GetSize();i++)
		{
			if(pDoc->blocklist[i].IsSelected==TRUE)
			{
				flg=TRUE;
				pDoc->blocklist[i].IsSelected=FALSE;
			}
		}
		
		if (flg==TRUE) RedrawView();
		
	}

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CFemmviewView::EnterPoint()
{
	CGetPoint pDlg;
	double x,y,t;
	CFemmviewDoc* pDoc = GetDocument();

	// Send present parameter values to the dialog
	// pDlg.m_rji=TheDoc->vi[0];

	if(pDoc->Coords==FALSE){
		pDlg.m_coord1 = mx;
		pDlg.m_coord2 = my;
		if(pDoc->ProblemType==0){
			pDlg.m_label1 = "x-coord";
			pDlg.m_label2 = "y-coord";
		}
		else{
			pDlg.m_label1 = "r-coord";
			pDlg.m_label2 = "z-coord";
		}
	}
	else{
		pDlg.m_coord1=sqrt(mx*mx+my*my);
		pDlg.m_coord2=atan2(my,mx)*180/PI;
		pDlg.m_label1="radius";
		pDlg.m_label2="degrees";
	}
	
	// Display dialog and collect data
	if(pDlg.DoModal()==IDOK)
	{
		if(pDoc->Coords==FALSE){
			x=pDlg.m_coord1;
			y=pDlg.m_coord2;
		}
		else{
			t=pDlg.m_coord2*PI/180;
			x=pDlg.m_coord1*cos(t);
			y=pDlg.m_coord1*sin(t);
		}
		if (EditAction==0) DisplayPointProperties(x,y);
		if (EditAction==1){
			CComplex z;
			z.Set(x,y);
			pDoc->contour.Add(z);
			DrawUserContour(FALSE);
		}
	}
}

void CFemmviewView::SpecialLine(CDC *pDC, int x0, int y0, int x1, int y1,
								int flag)
{
	double l;
	int i,j,k,p,x,y,z;
	int hi,lo,zj;
	BOOL InLine;
	COLORREF c;
	COLORREF Red;
	COLORREF White;
	RECT r;
		
	GetClientRect(&r);
	Red=SelColor;
	White=RGB(255,255,255);

	l=(double)((x1-x0)*(x1-x0) + (y1-y0)*(y1-y0));
	l=sqrt(l);
	k=(int) l;
	for(i=0;i<=k;i++)
	{
		if(k!=0){
			x=x0+((x1-x0)*i)/k;
			y=y0+((y1-y0)*i)/k;
		}
		else{
			x=x0;
			y=y0;
		}
		
		z=x+y*r.right;

		// check if this point is already in the line
		// in the case that a red line is supposed to be drawn;
	
		if(flag==FALSE)
		{
			// bisection search to see if the pixel under
			// consideration is already in LinePix
			InLine=FALSE;
			lo=0;
			hi=LinePix.GetSize()-1;
			if(hi>=0){
				zj=LinePix[0].z;
				if(z<=zj){
					hi=0;
					if(z==zj) InLine=TRUE;
				}
				zj=LinePix[hi].z;
				if(z>=zj){
					hi+=1;
					lo=hi;
					if(z==zj) InLine=TRUE;
				}
				while((hi-lo)>1){
					j=(lo+hi)/2;
					zj=LinePix[j].z;
					if(zj==z){
						InLine=TRUE;
						break;
					}
					else if(zj<z) lo=j; 
						 else hi=j;
				}
			}
			else hi=0;
		
			if(InLine==FALSE){
				CPixel NewPixel;
				NewPixel.z=z;
				NewPixel.c=pDC->GetPixel(x,y);
				if (hi==LinePix.GetSize()) LinePix.Add(NewPixel);
				else LinePix.InsertAt(hi,NewPixel);
			}
		}
		
		// if line is to be erased, get entry out of the pixel list
		if(flag!=FALSE){
			// bisection search to find the pixel
			InLine=FALSE;
			lo=0;
			hi=LinePix.GetSize()-1;
			if(hi>=0){
				zj=LinePix[0].z;
				if(z<=zj){
					hi=0;
					if(z==zj){
						InLine=TRUE;
						p=0;						
					}
				}
				zj=LinePix[hi].z;
				if(z>=zj){
					lo=hi;
					if(z==zj){
						InLine=TRUE;
						p=hi;
					}
				}
				while((hi-lo)>1){
					j=(lo+hi)/2;
					zj=LinePix[j].z;
					if(zj==z){
						InLine=TRUE;
						p=j;
						break;
					}
					else if(zj<z) lo=j; 
						 else hi=j;
				}
			}
	
			if(InLine==TRUE){
				c=LinePix[p].c;
				LinePix.RemoveAt(p);
			}

		}

		if(pDC->PtVisible(x,y)!=FALSE)
		{
			if(flag==FALSE) pDC->SetPixel(x,y,Red);
			else if(InLine==TRUE) pDC->SetPixel(x,y,c);
		}
	}	
}


void CFemmviewView::OnMenuPlot() 
{
	// TODO: Add your command handler code here
	CXYPlotDlg dlg;
	CFemmviewDoc *pDoc=GetDocument();
	int PlotType,npoints,FileFormat;
	BOOL ToFile;

	if ((EditAction!=1) || (pDoc->contour.GetSize()==0)){
		AfxMessageBox("Cannot create a plot;\nNo contour has been defined");
		return;
	}

	if (pDoc->Frequency==0) dlg.ListType=0;
	else dlg.ListType=1;

	if (dlg.DoModal()==IDOK){
		PlotType=dlg.XYPlotType;
		FileFormat=dlg.FileFormat;
		ToFile=dlg.m_ToFile;
		npoints=dlg.m_npoints;
		CXYPlot xyplot;
		BeginWaitCursor();
 		pDoc->GetLineValues(xyplot,PlotType,npoints);
		EndWaitCursor();
		if(ToFile==FALSE){
			CMetaFileDC Meta;	
			Meta.CreateEnhanced(NULL,NULL,NULL,NULL);
			HGLOBAL BoundingBox=GlobalAlloc(0,256);
			xyplot.MakePlot(&Meta,(char *) BoundingBox);
			HENHMETAFILE hMeta=Meta.CloseEnhanced();
			if (hMeta==NULL) AfxMessageBox("No Handle...");
			if (OpenClipboard()==FALSE)
				AfxMessageBox("Cannot access the Clipboard");
			else{
				EmptyClipboard();
				if(SetClipboardData(CF_ENHMETAFILE,hMeta)==NULL)
					AfxMessageBox("Couldn't SetClipboardData");
				if(SetClipboardData(CF_TEXT,BoundingBox)==NULL)
					AfxMessageBox("Couldn't SetClipboardData");
				CloseClipboard();

				char CommandLine[512];

			#ifdef _DEBUG
				sprintf(CommandLine,"c:\\femmsrc\\femmplot\\debug\\femmplot.exe");
			#else
				sprintf(CommandLine,"\"%sfemmplot.exe\"",BinDir);
			#endif

				STARTUPINFO StartupInfo2 = {0};
				PROCESS_INFORMATION ProcessInfo2;
				StartupInfo2.cb = sizeof(STARTUPINFO);
				if (CreateProcess(NULL,CommandLine, NULL, NULL, FALSE,
					0, NULL, NULL, &StartupInfo2, &ProcessInfo2)){
				}
				else
				{
					AfxMessageBox("Problem executing femmplot");
					return;
				}
			} 
		}
		else xyplot.ToDisk(FileFormat);
	}	
}

void CFemmviewView::OnMenuIntegrate() 
{
	// TODO: Add your command handler code here
	
	CFemmviewDoc *pDoc=GetDocument();
	int inttype;

	if (EditAction==0){
		AfxMessageBox("Cannot integrate;\nNo contour or area\nhas been defined.");
		return;
	}

	if ((EditAction==1) && (pDoc->contour.GetSize()==0)){
		AfxMessageBox("Cannot integrate;\nNo contour has been defined");
		return;
	}

	if (EditAction==2){
		int i;
		BOOL flg=FALSE;
		for(i=0;i<pDoc->blocklist.GetSize();i++)
			if (pDoc->blocklist[i].IsSelected==TRUE) flg=TRUE;
		if(flg==FALSE){
			AfxMessageBox("Cannot integrate;\nNo area has been selected");
			return;
		}
	}

	if(EditAction==1){
		CLIntDlg dlg;
		int inttype;

		if(dlg.DoModal()==IDOK){
			inttype=dlg.linttype;
			char s[512]; char c[80]; char d[80];
			CComplex *z;
			switch(inttype)
			{
				case 0:
					z=(CComplex *)calloc(2,sizeof(CComplex));
					pDoc->LineIntegral(inttype,z);
					if(pDoc->ProblemType==0){
						if(pDoc->Frequency==0)
							sprintf(s,"Normal flux = %.3e Webers/meter\nAverage B.n = %.3e Tesla",z[0].re,z[1].re);
						else
							sprintf(s,"Normal flux = %s Webers/meter\nAverage B.n = %s Tesla",z[0].ToString(c),z[1].ToString(d));
					}
					else{
						if(pDoc->Frequency==0)
							sprintf(s,"Normal flux = %.3e Webers\nAverage B.n = %.3e Tesla",z[0].re,z[1].re);
						else
							sprintf(s,"Normal flux = %s Webers\nAverage B.n = %s Tesla",z[0].ToString(c),z[1].ToString(d));
					}
					MyMessageBox(s);
					// AfxMessageBox(s,MB_ICONINFORMATION);
					free(z);
					break;
				
				case 1:
					z=(CComplex *)calloc(2,sizeof(CComplex));
					BeginWaitCursor();
					pDoc->LineIntegral(inttype,z);
					EndWaitCursor();
					if(pDoc->Frequency==0)
						sprintf(s,"MMF drop along contour = %.3e Amp-turns\nAverage H.t = %.3e Amp/Meter",z[0].re,z[1].re);
					else
						sprintf(s,"MMF drop along contour = %s Amp-turns\nAverage H.t = %s Amp/Meter",z[0].ToString(c),z[1].ToString(d));
					
					MyMessageBox(s);
					// AfxMessageBox(s,MB_ICONINFORMATION);
					free(z);
					break;
				case 2:
					z=(CComplex *)calloc(1,sizeof(CComplex));
					pDoc->LineIntegral(inttype,z);
					if(pDoc->ProblemType==0)
						sprintf(s,"Contour length = %.3e meters",z[0].re);
					else
						sprintf(s,"Contour length = %.3e meters\nSurface Area = %.3e meter^2",z[0].re,z[0].im);
					MyMessageBox(s);
					// AfxMessageBox(s,MB_ICONINFORMATION);
					free(z);
					break;
				case 3:
					z=(CComplex *)calloc(4,sizeof(CComplex));
					BeginWaitCursor();
					pDoc->LineIntegral(inttype,z);
					EndWaitCursor();
					if(pDoc->Frequency==0)
					{
						if (pDoc->ProblemType==0)
							sprintf(s,"Force in x-direction = %.3e N/m\nForce in y-direction = %.3e N/m\n",z[0].re,z[1].re);
						else
							sprintf(s,"Force in z-direction = %.3e N",z[1].re);
						MyMessageBox(s);
						// AfxMessageBox(s,MB_ICONINFORMATION);
					}	
					else{
						CString ss;
						if (pDoc->ProblemType==0){
							sprintf(s,"DC Force:\n x-direction = %.3e N/m\n y-direction = %.3e N/m\n",z[2].re,z[3].re);
							ss=s;
							sprintf(s,"\n%f Hz Force:\n x-direction = %s N/m\n y-direction = %s N/m",
								pDoc->Frequency*2.,z[0].ToString(c),z[1].ToString(d));
							ss+=s;
						}
						else{
							sprintf(s,"DC Force:\n z-direction = %.3e N",z[3].re);
							ss=s;
							sprintf(s,"\n%f Hz Force:\n z-direction = %s N",
								pDoc->Frequency*2.,z[1].ToString(c));
							ss+=s;
						}
						
						MyMessageBox(ss);
						// AfxMessageBox(ss,MB_ICONINFORMATION);
					}		
					free(z);
					break;

				case 4:
					z=(CComplex *)calloc(2,sizeof(CComplex));
					BeginWaitCursor();
					pDoc->LineIntegral(inttype,z);
					EndWaitCursor();
					if(pDoc->Frequency==0)
					{
						if (pDoc->ProblemType==0)
							sprintf(s,"Torque about (0,0) = %.3e N*m/m",z[0].re);
						else
							sprintf(s,"No net torque in axisymmetric case.");
						
						MyMessageBox(s);
						// AfxMessageBox(s,MB_ICONINFORMATION);
					}
					else{
						CString ss;
						if (pDoc->ProblemType==0){
							sprintf(s,"Torque about (0,0):\nDC Torque = %.3e N*m/m\n",z[1].re);
							ss=s;
							sprintf(s,"%f Hz Torque = %s N*m/m",
								pDoc->Frequency*2.,z[0].ToString(c));
							ss+=s;
						}
						else{
							sprintf(s,"No net torque in axisymmetric case");
							ss=s;
						}
					
						MyMessageBox(ss);
						//AfxMessageBox(ss,MB_ICONINFORMATION);
					}			
					
					free(z);
					break;

				case 5:
					z=(CComplex *)calloc(2,sizeof(CComplex));
					pDoc->LineIntegral(inttype,z);
					if(pDoc->ProblemType==0){
						if(pDoc->Frequency==0)
							sprintf(s,"Result = %.3e Webers^2/meter\nAverage (B.n)^2 = %.3e Tesla^2",z[0].re,z[1].re);
						else
							sprintf(s,"Result = %s Webers^2/meter\nAverage (B.n)^2 = %s Tesla^2",z[0].ToString(c),z[1].ToString(d));
					}
					else{
						if(pDoc->Frequency==0)
							sprintf(s,"Result = %.3e Webers^2\nAverage (B.n)^2 = %.3e Tesla^2",z[0].re,z[1].re);
						else
							sprintf(s,"Result = %s Webers^2\nAverage (B.n)^2 = %s Tesla^2",z[0].ToString(c),z[1].ToString(d));
					}

				    MyMessageBox(s);
					free(z);
					break;
/*
	// this is really an implemenation of something like a virtual
	// work approach to finding force.  I decided that I didn't
	// really like it, so I commented it out.  However, it does
	// seem to work well enough...

				case 6:
					if (pDoc->ContourClosed==FALSE)
						AfxMessageBox("contour must be closed to perform this integral");
					else{
						if(pDoc->Frequency==0)
						{
							double fx,fy;
							BeginWaitCursor();
							pDoc->AvgMaxwell(fx,fy);
							EndWaitCursor();
							if(pDoc->ProblemType==0)
								sprintf(s,"Force in x-direction = %.3e N/m\nForce in y-direction = %.3e N/m\n",fx,fy);
							else
								sprintf(s,"Force in z-direction = %.3e N",fy);
							MyMessageBox(s);
						}
						else{
							double fx,fy;
							CString ss;
							CComplex f2x,f2y;
							BeginWaitCursor();
							pDoc->AvgMaxwell(fx,fy,f2x,f2y);
							EndWaitCursor();
							if(pDoc->ProblemType==0){
								sprintf(s,"DC Force:\n x-direction = %.3e N/m\n y-direction = %.3e N/m\n",fx,fy);
								ss=s;
								sprintf(s,"\n%f Hz Force:\n x-direction = %s N/m\n y-direction = %s N/m",
									pDoc->Frequency*2.,f2x.ToString(c),f2y.ToString(d));
								ss+=s;
							}
							else{
								sprintf(s,"DC Force:\n z-direction = %.3e N",fy);
								ss=s;
								sprintf(s,"\n%f Hz Force:\n z-direction = %s N",
									pDoc->Frequency*2.,f2y.ToString(c));
								ss+=s;
							}
							MyMessageBox(ss);
						}
					}
					break;
*/
				default:
					// sprintf(s,"%s",z.ToString(c));
					break;
			}
			
		}

	}

	if(EditAction==2){
		CBlockInt dlg;

		if(dlg.DoModal()==IDOK){
			inttype=dlg.binttype;
			CComplex z,z1,z2,z3,z4;
			char s[512]; char c[80]; char d[80];
			switch(inttype)
			{
				case 0:
					z=pDoc->BlockIntegral(inttype);
					if((pDoc->ProblemType==0) && (pDoc->Frequency==0))
						sprintf(s,"%e Henry Amp^2 / meter",z.re);
					if((pDoc->ProblemType==0) && (pDoc->Frequency!=0))
						sprintf(s,"%s Henry Amp^2 / meter",z.ToString(c));
					if((pDoc->ProblemType==1) && (pDoc->Frequency==0))
						sprintf(s,"%e Henry Amp^2",z.re);
					if((pDoc->ProblemType==1) && (pDoc->Frequency!=0))
						sprintf(s,"%s Henry Amp^2",z.ToString(c));
					break;
				case 1:
					z=pDoc->BlockIntegral(inttype);
					if((pDoc->ProblemType==0) && (pDoc->Frequency==0))
						sprintf(s,"%e Joule meter/Amp",z.re);
					if((pDoc->ProblemType==0) && (pDoc->Frequency!=0))
						sprintf(s,"%s Joule meter/Amp",z.ToString(c));
					if((pDoc->ProblemType==1) && (pDoc->Frequency==0))
						sprintf(s,"%e Joule meter^2/Amp",z.re);
					if((pDoc->ProblemType==1) && (pDoc->Frequency!=0))
						sprintf(s,"%s Joule meter^2/Amp",z.ToString(c));
					break;
				case 2:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e Joules / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e Joules",z.re);
					break;

				case 3:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e Watts / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e Watts",z.re);
					break;

				case 4:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e Watts / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e Watts",z.re);
					break;

				case 5:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e meter^2",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e meter^2",z.re);
					break;

				case 6:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e Watts / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e Watts",z.re);
					break;

				case 7:
					z=pDoc->BlockIntegral(inttype);
					if(pDoc->Frequency==0)
						sprintf(s,"%e Amps",z.re);
					else
						sprintf(s,"%s Amps",z.ToString(c));
					break;
				
				case 8:
					z1=pDoc->BlockIntegral(8);
					z2=pDoc->BlockIntegral(9);
					if((pDoc->ProblemType==0) && (pDoc->Frequency==0))
						sprintf(s,"x-component: %e Tesla meter^2\ny-component: %e Tesla meter^2",z1.re,z2.re);
					if((pDoc->ProblemType==0) && (pDoc->Frequency!=0))
						sprintf(s,"x-component: %s Tesla meter^2\ny-component: %s Tesla meter^2",z1.ToString(c),z2.ToString(d));
					if((pDoc->ProblemType==1) && (pDoc->Frequency==0))
						sprintf(s,"r-component: %e Tesla meter^3\nz-component: %e Tesla meter^3",z1.re,z2.re);
					if((pDoc->ProblemType==1) && (pDoc->Frequency!=0))
						sprintf(s,"r-component: %s Tesla meter^3\nz-component: %s Tesla meter^3",z1.ToString(c),z2.ToString(d));
					break;
                case 9:
					z=pDoc->BlockIntegral(10);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e meter^3 / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e meter^3",z.re);
					break;
				case 10:
					z1=pDoc->BlockIntegral(11);
					z2=pDoc->BlockIntegral(12);
					if(pDoc->Frequency!=0){
						z3=pDoc->BlockIntegral(13);
						z4=pDoc->BlockIntegral(14);
					}
					if((pDoc->ProblemType==0) && (pDoc->Frequency==0))
						sprintf(s,"x-component: %e N/m\ny-component: %e N/m",z1.re,z2.re);
					if((pDoc->ProblemType==1) && (pDoc->Frequency==0))
						sprintf(s,"r-component: %e N\nz-component: %e N",0.,z2.re);
					if((pDoc->ProblemType==0) && (pDoc->Frequency!=0))
						sprintf(s,"Steady-state force:\nx-component: %e N/m\ny-component: %e N/m\n2x Frequency force:\nx-component: %s N/m\ny-component: %s N/m",
						z1.re,z2.re,z3.ToString(c),z4.ToString(d));
					if((pDoc->ProblemType==1) && (pDoc->Frequency!=0))
						sprintf(s,"Steady-state force:\nr-component: 0. N\nz-component: %e N\n2x Frequency force:\nr-component: 0. N\nz-component: %s N",
						z2.re,z4.ToString(d));
					break;
				case 11:
					z1=pDoc->BlockIntegral(15);
					z2=pDoc->BlockIntegral(16);
					if((pDoc->ProblemType==0) && (pDoc->Frequency==0))
						sprintf(s,"Torque about (0,0): %e N*m/m",z1.re);
					if((pDoc->ProblemType==0) && (pDoc->Frequency!=0))
						sprintf(s,"Torque about (0,0):\nSteady State: %e N*m/m\n2x Frequency: %s",
							z1.re,z2.ToString(d));

					if(pDoc->ProblemType==1)
						sprintf(s,"No Lorentz torque possible in axisymmetric case");
					break;
				case 12:
					z=pDoc->BlockIntegral(17);
					if(pDoc->ProblemType==0)
						sprintf(s,"%e Joules / meter",z.re);
					if(pDoc->ProblemType==1)
						sprintf(s,"%e Joules",z.re);
					break;

				default:
					sprintf(s,"%s",z.ToString(c));
					break;
			}
			MyMessageBox(s);
			// AfxMessageBox(s,MB_ICONINFORMATION);
		}

	}
}



void CFemmviewView::OnSmooth() 
{
	// TODO: Add your command handler code here
	CFemmviewDoc *pDoc=GetDocument();
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CMenu* MMnu=MFrm->GetMenu();
	
	if (pDoc->Smooth==TRUE){
		pDoc->Smooth=FALSE;
		MMnu->CheckMenuItem(ID_SMOOTH, MF_UNCHECKED);
	}
	else{
		pDoc->Smooth=TRUE;
		MMnu->CheckMenuItem(ID_SMOOTH, MF_CHECKED);
	}
	RedrawView();
}

BOOL CFemmviewView::OnEraseBkgnd(CDC* pDC) 
{
	
	 // Set brush to desired background color
     CBrush backBrush(BackColor);
 
     // Save old brush
     CBrush* pOldBrush = pDC->SelectObject(&backBrush);
 
     CRect rect;
     pDC->GetClipBox(&rect);     // Erase the area needed
 
     pDC->PatBlt(rect.left, rect.top, rect.Width(),
		rect.Height(), PATCOPY);
     pDC->SelectObject(pOldBrush);
     
	 return TRUE;

}

void CFemmviewView::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CFemmviewDoc *pDoc=GetDocument();

	if(EditAction==0){
		int i=pDoc->ClosestNode(mx,my);
		if(i>=0){
			char s[256];
			sprintf(s,"Closest input node:\n(%.4f,%.4f)",pDoc->nodelist[i].x,
				pDoc->nodelist[i].y);
			AfxMessageBox(s,MB_ICONINFORMATION);
		}
	}
	
	CView::OnRButtonDblClk(nFlags, point);
}




void CFemmviewView::OnPanDown() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;
//	ox=ox-0.25*x/mag;
	oy-=0.25*y/mag;

	RedrawView();
}

void CFemmviewView::OnPanLeft() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;
	ox-=0.25*x/mag;
//	oy-=0.25*y/mag;

	RedrawView();
}

void CFemmviewView::OnPanRight() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;
	ox+=0.25*x/mag;
//	oy-=0.25*y/mag;

	RedrawView();
}

void CFemmviewView::OnPanUp() 
{
	// TODO: Add your command handler code here
	RECT r;
	double x,y;

	GetClientRect(&r);
	x=r.right; y=r.bottom;
//	ox+=0.25*x/mag;
	oy+=0.25*y/mag;

	RedrawView();
}

/*
void CFemmviewView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CMainFrame *MFrm;
	MFrm=(CMainFrame *)GetParentFrame();
	CDC *pDC=GetDC();
	CPalette *oldPalette=pDC->SelectPalette(&MFrm->myPalette,FALSE);
	pDC->RealizePalette();
	pDC->SelectPalette(oldPalette,TRUE);
	ReleaseDC(pDC);
	CView::OnUpdate(pSender,lHint,pHint);
}
*/

void CFemmviewView::OnHelpFinder() 
{
	// TODO: Add your command handler code here

#ifdef _DEBUG
	ShellExecute(m_hWnd,"open","c:\\femmsrc\\manual\\manual.pdf","","",0);
#else
	CString manualname=BinDir+"manual.pdf";
	ShellExecute(m_hWnd,"open",manualname,"","",0);
#endif

}

void CFemmviewView::OnViewCircprops() 
{
	CCircDlg dlg;

	dlg.TheDoc=GetDocument();
	dlg.DoModal();

}

void CFemmviewView::RedrawView()
{
	LinePix.RemoveAll();
	InvalidateRect(NULL);
}
