// femmviewView.h : interface of the CFemmviewView class
//
/////////////////////////////////////////////////////////////////////////////
#include "OutBox.h"

class CPixel
{
	public:
		int z;
		COLORREF c;
};

class CZPix
{
	public:
		int x,y;
		COLORREF c;
};

class CFemmviewView : public CView
{
protected: // create from serialization only
	CFemmviewView();
	DECLARE_DYNCREATE(CFemmviewView)

// Attributes
public:
	
	CFemmviewDoc* GetDocument();

	void ScreenToDwg(int xs, int ys, double *xd, double *yd, RECT *r);
	BOOL DwgToScreen(double xd, double yd, int *xs, int *ys, RECT *r);
	void EnterPoint();
	
	int EditAction;				// tells if operating on points, lines, or blox
	double mx,my;				// location of the mouse in model coordinates
	double ox,oy,mag;			// location of lower left corner & scaling factor
	CStatusBar* StatBar;		// pointer to the main window's status bar
	double GridSize;			// size of each block in the grid
	BOOL   GridFlag;			// Flag telling whether or not to show grid
	BOOL   SnapFlag;
	BOOL   MeshFlag;
	BOOL   LegendFlag;
	BOOL   GreyContours;
	BOOL   PtsFlag;
	BOOL   Coords;				// False=Cartesian; True=Polar
	int	   FirstPoint;
	int    ZoomWndFlag;
	int	   DrawSelected;
	double wzx,wzy;

	CDialogBar *Dspl;
	CString BinDir;		// pathname for triangle.exe

	int	   NumContours;
	BOOL   ShowAr,ShowAi;
	int	   DensityPlot;

	CArray< CPixel, CPixel& > LinePix;
	CArray< CZPix,  CZPix&  > ZoomPix;

	// Greyscale Density Plot Colormap
	COLORREF Grey0;
	COLORREF Grey1;
	COLORREF Grey2;
	COLORREF Grey3;
	COLORREF Grey4;
	COLORREF Grey5;
	COLORREF Grey6;
	COLORREF Grey7;
	COLORREF Grey8;
	COLORREF Grey9;
	COLORREF GreyA;
	COLORREF GreyB;

	// Density Plot Colormap
	COLORREF Color0;
	COLORREF Color1;
	COLORREF Color2;
	COLORREF Color3;
	COLORREF Color4;
	COLORREF Color5;
	COLORREF Color6;
	COLORREF Color7;
	COLORREF Color8;
	COLORREF Color9;
	COLORREF ColorA;
	COLORREF ColorB;

	// Other colors
	COLORREF SelColor;
	COLORREF MeshColor;  
	COLORREF BlockColor; 
	COLORREF LineColor;  
	COLORREF RegionColor; 
	COLORREF GridColor;  
	COLORREF BackColor;  
	COLORREF TextColor;  
	COLORREF NodeColor;
	COLORREF RealFluxLineColor;
	COLORREF ImagFluxLineColor;

// Operations
public:

	void DoContours(CDC *pDC, int *p, int side, int Aflag);
	void PlotFluxDensity(CDC *pDC,CElement &elm,int flag);
	void DisplayPointProperties(double px, double py);
	void DrawUserContour(BOOL flag);
	void EraseUserContour(BOOL flag);
	void SpecialLine(CDC *pDC, int x0, int y0, int x1, int y1, BOOL flag);
	void PlotSelectedElm(CDC *pDC,CElement &elm);
	void RedrawView();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFemmviewView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFemmviewView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFemmviewView)
	afx_msg void OnZoomIn();
	afx_msg void OnSnapGrid();
	afx_msg void OnShowMesh();
	afx_msg void OnShowGrid();
	afx_msg void OnSetGrid();
	afx_msg void OnCplot();
	afx_msg void OnDplot();
	afx_msg void OnZoomNatural();
	afx_msg void OnZoomOut();
	afx_msg void OnZoomWindow();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnEditCopy();
	afx_msg void OnReload();
	afx_msg void OnMenuArea();
	afx_msg void OnMenuContour();
	afx_msg void OnMenuPoint();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMenuPlot();
	afx_msg void OnMenuIntegrate();
	afx_msg void OnMenushowpts();
	afx_msg void OnKbdZoom();
	afx_msg void OnSmooth();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnPanDown();
	afx_msg void OnPanLeft();
	afx_msg void OnPanRight();
	afx_msg void OnPanUp();
	afx_msg void OnHelpFinder();
	afx_msg void OnViewCircprops();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in femmviewView.cpp
inline CFemmviewDoc* CFemmviewView::GetDocument()
   { return (CFemmviewDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////


