// femmeDoc.h : interface of the CFemmeDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CFemmeDocCore
{



// Attributes
public:

	// General problem attributes
	double  Frequency;
	double  Precision;
	int		LengthUnits;
	BOOL    ProblemType;
	BOOL	Coords;
	
	CFknDlg *TheView;
	
	// CArrays containing the mesh information
	int	BandWidth;
	CNode *meshnode;
	CElement	*meshele;

	int NumNodes;
	int NumEls;
	
	// lists of properties
	int NumBlockProps;
	int NumPBCs;
	int NumLineProps;
	int NumPointProps;
	int NumCircProps;
	int NumBlockLabels;

	CMaterialProp	*blockproplist;
	CBoundaryProp	*lineproplist;
	CPointProp		*nodeproplist;
	CCircuit		*circproplist;
	CBlockLabel		*labellist;
	CCommonPoint	*pbclist;
	// stuff usually kept track of by CDocument
	char *PathName;
	

// Operations
public:

	BOOL LoadMesh();
	BOOL OnOpenDocument();
	BOOL Cuthill();
	BOOL Static2D(CBigLinProb &L);
	BOOL WriteStatic2D(CBigLinProb &L);
	BOOL Harmonic2D(CBigComplexLinProb &L);
	BOOL WriteHarmonic2D(CBigComplexLinProb &L);
	BOOL StaticAxisymmetric(CBigLinProb &L);
	BOOL HarmonicAxisymmetric(CBigComplexLinProb &L);
	
	~CFemmeDocCore();
	CFemmeDocCore();

};

/////////////////////////////////////////////////////////////////////////////

double GetNewMu(double mu,int BHpoints, CComplex *BHdata,double muc,double B);
double Power(double x, int n);
