// wintriangle.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "wintriangle.h"
#include "wintriangleDlg.h"
#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWintriangleApp

BEGIN_MESSAGE_MAP(CWintriangleApp, CWinApp)
	//{{AFX_MSG_MAP(CWintriangleApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWintriangleApp construction

CWintriangleApp::CWintriangleApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWintriangleApp object

CWintriangleApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWintriangleApp initialization

BOOL CWintriangleApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	CWintriangleDlg dlg;
	m_pMainWnd = &dlg;

	char *comline,*c,**av;	
	int ac,i,j,k,m,n;
	BOOL bQuote=FALSE;
	BOOL bRunTriangle=TRUE;

	// parse commandline into a form that triangle can understand
	comline=GetCommandLine();
	k=strlen(comline);
	c=(char *)calloc(k+1,sizeof(char));
	strcpy(c,comline);
	c[k]=' ';

	av=(char **)calloc(k,sizeof(char *));
	for(i=0;i<k;i++)
		av[i]=(char *)calloc(k,sizeof(char*));
	for(i=0,ac=0,j=0;i<=k;i++){
		if(c[i]=='\"'){
			if(bQuote==FALSE){
				bQuote=TRUE;
				j=i+1;
			}
			else{
				bQuote=FALSE;
				c[i]=' ';
			}
		}

		if((c[i]==' ') && (i>0)){
			if ((c[i-1]!=' ') && (bQuote==FALSE)){
				for(n=j,m=0;n<i;n++,m++)
					av[ac][m]=c[n];
				av[ac][n]=NULL;
				ac++;
				j=i+1;
			}
			if (c[i-1]==' ') j=i+1;
		}
		else if (c[i]==' ') j=i+1;
	}
	
	dlg.argv=av;
	dlg.argc=ac;

	if(ac<2){
		bRunTriangle=FALSE;
		dlg.m_info="triangle [-prq__a__AcevngBPNEIOXzo_YS__lQVh] input_file\x0D\x0A";
		dlg.m_info+="    -p  Triangulates a Planar Straight Line Graph (.poly file).\x0D\x0A";
		dlg.m_info+="    -r  Refines a previously generated mesh.\x0D\x0A";
		dlg.m_info+="    -q  Quality mesh generation.  A minimum angle may be specified.\x0D\x0A";
		dlg.m_info+="    -a  Applies a maximum triangle area constraint.\x0D\x0A";
		dlg.m_info+="    -A  Applies attributes to identify elements in certain regions.\x0D\x0A";
		dlg.m_info+="    -c  Encloses the convex hull with segments.\x0D\x0A";
		dlg.m_info+="    -e  Generates an edge list.\x0D\x0A";
		dlg.m_info+="    -v  Generates a Voronoi diagram.\x0D\x0A";
		dlg.m_info+="    -n  Generates a list of triangle neighbors.\x0D\x0A";
		dlg.m_info+="    -g  Generates an .off file for Geomview.\x0D\x0A";
		dlg.m_info+="    -B  Suppresses output of boundary information.\x0D\x0A";
		dlg.m_info+="    -P  Suppresses output of .poly file.\x0D\x0A";
		dlg.m_info+="    -N  Suppresses output of .node file.\x0D\x0A";
		dlg.m_info+="    -E  Suppresses output of .ele file.\x0D\x0A";
		dlg.m_info+="    -I  Suppresses mesh iteration numbers.\x0D\x0A";
		dlg.m_info+="    -O  Ignores holes in .poly file.\x0D\x0A";
		dlg.m_info+="    -X  Suppresses use of exact arithmetic.\x0D\x0A";
		dlg.m_info+="    -z  Numbers all items starting from zero (rather than one).\x0D\x0A";
		dlg.m_info+="    -o2 Generates second-order subparametric elements.\x0D\x0A";
		dlg.m_info+="    -Y  Suppresses boundary segment splitting.\x0D\x0A";
		dlg.m_info+="    -S  Specifies maximum number of added Steiner points.\x0D\x0A";
		dlg.m_info+="    -l  Uses vertical cuts only, rather than alternating cuts.\x0D\x0A";
	//	dlg.m_info+="    -Q  Quiet:  No terminal output except errors.\x0D\x0A";
	//	dlg.m_info+="    -V  Verbose:  Detailed information on what I'm doing.\x0D\x0A";
		dlg.m_info+="    -h  Help:  Detailed instructions for Triangle.";
	}

	for(i=0;i<ac;i++) 
		if((strncmp(av[i],"-?",2)==0) || (strncmp(av[i],"-h",2)==0))
		{
			i=ac; bRunTriangle=FALSE;
			dlg.m_info="Triangle\x0D\x0A";
			dlg.m_info+="A Two-Dimensional Quality Mesh Generator and Delaunay Triangulator.\x0D\x0A";
			dlg.m_info+="Version 1.3\x0D\x0A\x0D\x0A";
			dlg.m_info+="Copyright 1996 Jonathan Richard Shewchuk  (bugs/comments to jrs@cs.cmu.edu)\x0D\x0A";
			dlg.m_info+="School of Computer Science / Carnegie Mellon University\x0D\x0A";
			dlg.m_info+="5000 Forbes Avenue / Pittsburgh, Pennsylvania  15213-3891\x0D\x0A";
			dlg.m_info+="Created as part of the Archimedes project (tools for parallel FEM).\x0D\x0A";
			dlg.m_info+="Supported in part by NSF Grant CMS-9318163 and an NSERC 1967 Scholarship.\x0D\x0A";
			dlg.m_info+="There is no warranty whatsoever.  Use at your own risk.\x0D\x0A";
			dlg.m_info+="This executable is compiled for double precision arithmetic.\x0D\x0A\x0D\x0A\x0D\x0A";
			dlg.m_info+="Triangle generates exact Delaunay triangulations, constrained Delaunay\x0D\x0A";
			dlg.m_info+="triangulations, and quality conforming Delaunay triangulations.  The latter\x0D\x0A";
			dlg.m_info+="can be generated with no small angles, and are thus suitable for finite\x0D\x0A";
			dlg.m_info+="element analysis.  If no command line switches are specified, your .node\x0D\x0A";
			dlg.m_info+="input file will be read, and the Delaunay triangulation will be returned in\x0D\x0A";
			dlg.m_info+=".node and .ele output files.  The command syntax is:\x0D\x0A\x0D\x0A";
			dlg.m_info+="triangle [-prq__a__AcevngBPNEIOXzo_YS__lQVh] input_file\x0D\x0A\x0D\x0A";
			dlg.m_info+="Underscores indicate that numbers may optionally follow certain switches;\x0D\x0A";
			dlg.m_info+="do not leave any space between a switch and its numeric parameter.\x0D\x0A";
			dlg.m_info+="input_file must be a file with extension .node, or extension .poly if the\x0D\x0A";
			dlg.m_info+="-p switch is used.  If -r is used, you must supply .node and .ele files,\x0D\x0A";
			dlg.m_info+="and possibly a .poly file and .area file as well.  The formats of these\x0D\x0A";
			dlg.m_info+="files are described below.\x0D\x0A\x0D\x0A";
			dlg.m_info+="Command Line Switches:\x0D\x0A\x0D\x0A";
            dlg.m_info+="    -p  Reads a Planar Straight Line Graph (.poly file), which can specify\x0D\x0A";
            dlg.m_info+="        points, segments, holes, and regional attributes and area\x0D\x0A";
            dlg.m_info+="        constraints.  Will generate a constrained Delaunay triangulation\x0D\x0A";
            dlg.m_info+="        fitting the input; or, if -s, -q, or -a is used, a conforming\x0D\x0A";
            dlg.m_info+="        Delaunay triangulation.  If -p is not used, Triangle reads a .node\x0D\x0A";
            dlg.m_info+="        file by default.\x0D\x0A";
            dlg.m_info+="    -r  Refines a previously generated mesh.  The mesh is read from a .node\x0D\x0A";
            dlg.m_info+="        file and an .ele file.  If -p is also used, a .poly file is read\x0D\x0A";
            dlg.m_info+="        and used to constrain edges in the mesh.  Further details on\x0D\x0A";
            dlg.m_info+="        refinement are given below.\x0D\x0A";
            dlg.m_info+="    -q  Quality mesh generation by Jim Ruppert's Delaunay refinement\x0D\x0A";
            dlg.m_info+="        algorithm.  Adds points to the mesh to ensure that no angles\x0D\x0A";
            dlg.m_info+="        smaller than 20 degrees occur.  An alternative minimum angle may be\x0D\x0A"
;
            dlg.m_info+="        specified after the `q'.  If the minimum angle is 20.7 degrees or\x0D\x0A";
            dlg.m_info+="        smaller, the triangulation algorithm is theoretically guaranteed to\x0D\x0A"
;
            dlg.m_info+="        terminate (assuming infinite precision arithmetic - Triangle may\x0D\x0A";
            dlg.m_info+="        fail to terminate if you run out of precision).  In practice, the\x0D\x0A";
            dlg.m_info+="        algorithm often succeeds for minimum angles up to 33.8 degrees.\x0D\x0A";
            dlg.m_info+="        For highly refined meshes, however, it may be necessary to reduce\x0D\x0A";
            dlg.m_info+="        the minimum angle to well below 20 to avoid problems associated\x0D\x0A";
            dlg.m_info+="        with insufficient floating-point precision.  The specified angle\x0D\x0A";
            dlg.m_info+="        may include a decimal point.\x0D\x0A";
            dlg.m_info+="    -a  Imposes a maximum triangle area.  If a number follows the `a', no\x0D\x0A";
            dlg.m_info+="        triangle will be generated whose area is larger than that number.\x0D\x0A";
            dlg.m_info+="        If no number is specified, an .area file (if -r is used) or .poly\x0D\x0A";
            dlg.m_info+="        file (if -r is not used) specifies a number of maximum area\x0D\x0A";
            dlg.m_info+="        constraints.  An .area file contains a separate area constraint for\x0D\x0A"
;
            dlg.m_info+="        each triangle, and is useful for refining a finite element mesh\x0D\x0A";
            dlg.m_info+="        based on a posteriori error estimates.  A .poly file can optionally\x0D\x0A"
;
            dlg.m_info+="        contain an area constraint for each segment-bounded region, thereby\x0D\x0A"
;
            dlg.m_info+="        enforcing triangle densities in a first triangulation.  You can\x0D\x0A";
            dlg.m_info+="        impose both a fixed area constraint and a varying area constraint\x0D\x0A";
            dlg.m_info+="        by invoking the -a switch twice, once with and once without a\x0D\x0A";
            dlg.m_info+="        number following.  Each area specified may include a decimal point.\x0D\x0A"
;
            dlg.m_info+="    -A  Assigns an additional attribute to each triangle that identifies\x0D\x0A";
            dlg.m_info+="        what segment-bounded region each triangle belongs to.  Attributes\x0D\x0A";
            dlg.m_info+="        are assigned to regions by the .poly file.  If a region is not\x0D\x0A";
            dlg.m_info+="        explicitly marked by the .poly file, triangles in that region are\x0D\x0A";
            dlg.m_info+="        assigned an attribute of zero.  The -A switch has an effect only\x0D\x0A";
            dlg.m_info+="        when the -p switch is used and the -r switch is not.\x0D\x0A";
            dlg.m_info+="    -c  Creates segments on the convex hull of the triangulation.  If you\x0D\x0A";
            dlg.m_info+="        are triangulating a point set, this switch causes a .poly file to\x0D\x0A";
            dlg.m_info+="        be written, containing all edges in the convex hull.  (By default,\x0D\x0A"
;
            dlg.m_info+="        a .poly file is written only if a .poly file is read.)  If you are\x0D\x0A"
;
            dlg.m_info+="        triangulating a PSLG, this switch specifies that the interior of\x0D\x0A";
            dlg.m_info+="        the convex hull of the PSLG should be triangulated.  If you do not\x0D\x0A"
;
            dlg.m_info+="        use this switch when triangulating a PSLG, it is assumed that you\x0D\x0A";
            dlg.m_info+="        have identified the region to be triangulated by surrounding it\x0D\x0A";
            dlg.m_info+="        with segments of the input PSLG.  Beware:  if you are not careful,\x0D\x0A"
;
            dlg.m_info+="        this switch can cause the introduction of an extremely thin angle\x0D\x0A";
            dlg.m_info+="        between a PSLG segment and a convex hull segment, which can cause\x0D\x0A";
            dlg.m_info+="        overrefinement or failure if Triangle runs out of precision.  If\x0D\x0A";
            dlg.m_info+="        you are refining a mesh, the -c switch works differently; it\x0D\x0A";
            dlg.m_info+="        generates the set of boundary edges of the mesh, rather than the\x0D\x0A";
            dlg.m_info+="        convex hull.\x0D\x0A";
            dlg.m_info+="    -e  Outputs (to an .edge file) a list of edges of the triangulation.\x0D\x0A";
            dlg.m_info+="    -v  Outputs the Voronoi diagram associated with the triangulation.\x0D\x0A";
            dlg.m_info+="        Does not attempt to detect degeneracies.\x0D\x0A";
            dlg.m_info+="    -n  Outputs (to a .neigh file) a list of triangles neighboring each\x0D\x0A";
            dlg.m_info+="        triangle.\x0D\x0A";
            dlg.m_info+="    -g  Outputs the mesh to an Object File Format (.off) file, suitable for\x0D\x0A"
;
            dlg.m_info+="        viewing with the Geometry Center's Geomview package.\x0D\x0A";
            dlg.m_info+="    -B  No boundary markers in the output .node, .poly, and .edge output\x0D\x0A";
            dlg.m_info+="        files.  See the detailed discussion of boundary markers below.\x0D\x0A";
            dlg.m_info+="    -P  No output .poly file.  Saves disk space, but you lose the ability\x0D\x0A";
            dlg.m_info+="        to impose segment constraints on later refinements of the mesh.\x0D\x0A";
            dlg.m_info+="    -N  No output .node file.\x0D\x0A";
            dlg.m_info+="    -E  No output .ele file.\x0D\x0A";
            dlg.m_info+="    -I  No iteration numbers.  Suppresses the output of .node and .poly\x0D\x0A";
            dlg.m_info+="        files, so your input files won't be overwritten.  (If your input is\x0D\x0A"
;
            dlg.m_info+="        a .poly file only, a .node file will be written.)  Cannot be used\x0D\x0A";
            dlg.m_info+="        with the -r switch, because that would overwrite your input .ele\x0D\x0A";
            dlg.m_info+="        file.  Shouldn't be used with the -s, -q, or -a switch if you are\x0D\x0A";
            dlg.m_info+="        using a .node file for input, because no .node file will be\x0D\x0A";
            dlg.m_info+="        written, so there will be no record of any added points.\x0D\x0A";
            dlg.m_info+="    -O  No holes.  Ignores the holes in the .poly file.\x0D\x0A";
            dlg.m_info+="    -X  No exact arithmetic.  Normally, Triangle uses exact floating-point\x0D\x0A"
;
            dlg.m_info+="        arithmetic for certain tests if it thinks the inexact tests are not\x0D\x0A"
;
            dlg.m_info+="        accurate enough.  Exact arithmetic ensures the robustness of the\x0D\x0A";
            dlg.m_info+="        triangulation algorithms, despite floating-point roundoff error.\x0D\x0A";
            dlg.m_info+="        Disabling exact arithmetic with the -X switch will cause a small\x0D\x0A";
            dlg.m_info+="        improvement in speed and create the possibility (albeit small) that\x0D\x0A"
;
            dlg.m_info+="        Triangle will fail to produce a valid mesh.  Not recommended.\x0D\x0A";
            dlg.m_info+="    -z  Numbers all items starting from zero (rather than one).  Note that\x0D\x0A"
;
            dlg.m_info+="        this switch is normally overrided by the value used to number the\x0D\x0A";
            dlg.m_info+="        first point of the input .node or .poly file.  However, this switch\x0D\x0A"
;
            dlg.m_info+="        is useful when calling Triangle from another program.\x0D\x0A";
            dlg.m_info+="    -o2 Generates second-order subparametric elements with six nodes each.\x0D\x0A"
;
            dlg.m_info+="    -Y  No new points on the boundary.  This switch is useful when the mesh\x0D\x0A"
;
            dlg.m_info+="        boundary must be preserved so that it conforms to some adjacent\x0D\x0A";
            dlg.m_info+="        mesh.  Be forewarned that you will probably sacrifice some of the\x0D\x0A";
            dlg.m_info+="        quality of the mesh; Triangle will try, but the resulting mesh may\x0D\x0A"
;
            dlg.m_info+="        contain triangles of poor aspect ratio.  Works well if all the\x0D\x0A";
            dlg.m_info+="        boundary points are closely spaced.  Specify this switch twice\x0D\x0A";
            dlg.m_info+="        (`-YY') to prevent all segment splitting, including internal\x0D\x0A";
            dlg.m_info+="        boundaries.\x0D\x0A";
            dlg.m_info+="    -S  Specifies the maximum number of Steiner points (points that are not\x0D\x0A"
;
            dlg.m_info+="        in the input, but are added to meet the constraints of minimum\x0D\x0A";
            dlg.m_info+="        angle and maximum area).  The default is to allow an unlimited\x0D\x0A";
            dlg.m_info+="        number.  If you specify this switch with no number after it,\x0D\x0A";
            dlg.m_info+="        the limit is set to zero.  Triangle always adds points at segment\x0D\x0A";
            dlg.m_info+="        intersections, even if it needs to use more points than the limit\x0D\x0A";
            dlg.m_info+="        you set.  When Triangle inserts segments by splitting (-s), it\x0D\x0A";
            dlg.m_info+="        always adds enough points to ensure that all the segments appear in\x0D\x0A"
;
            dlg.m_info+="        the triangulation, again ignoring the limit.  Be forewarned that\x0D\x0A";
            dlg.m_info+="        the -S switch may result in a conforming triangulation that is not\x0D\x0A"
;
            dlg.m_info+="        truly Delaunay, because Triangle may be forced to stop adding\x0D\x0A";
            dlg.m_info+="        points when the mesh is in a state where a segment is non-Delaunay\x0D\x0A"
;
            dlg.m_info+="        and needs to be split.  If so, Triangle will print a warning.\x0D\x0A";
            dlg.m_info+="    -i  Uses an incremental rather than divide-and-conquer algorithm to\x0D\x0A";
            dlg.m_info+="        form a Delaunay triangulation.  Try it if the divide-and-conquer\x0D\x0A";
            dlg.m_info+="        algorithm fails.\x0D\x0A";
            dlg.m_info+="    -F  Uses Steven Fortune's sweepline algorithm to form a Delaunay\x0D\x0A";
            dlg.m_info+="        triangulation.  Warning:  does not use exact arithmetic for all\x0D\x0A";
            dlg.m_info+="        calculations.  An exact result is not guaranteed.\x0D\x0A";
            dlg.m_info+="    -l  Uses only vertical cuts in the divide-and-conquer algorithm.  By\x0D\x0A";
            dlg.m_info+="        default, Triangle uses alternating vertical and horizontal cuts,\x0D\x0A";
            dlg.m_info+="        which usually improve the speed except with point sets that are\x0D\x0A";
            dlg.m_info+="        small or short and wide.  This switch is primarily of theoretical\x0D\x0A";
            dlg.m_info+="        interest.\x0D\x0A";
            dlg.m_info+="    -s  Specifies that segments should be forced into the triangulation by\x0D\x0A"
;
            dlg.m_info+="        recursively splitting them at their midpoints, rather than by\x0D\x0A";
            dlg.m_info+="        generating a constrained Delaunay triangulation.  Segment splitting\x0D\x0A"
;
            dlg.m_info+="        is true to Ruppert's original algorithm, but can create needlessly\x0D\x0A"
;
            dlg.m_info+="        small triangles near external small features.\x0D\x0A";
            dlg.m_info+="    -C  Check the consistency of the final mesh.  Uses exact arithmetic for\x0D\x0A"
;
            dlg.m_info+="        checking, even if the -X switch is used.  Useful if you suspect\x0D\x0A";
            dlg.m_info+="        Triangle is buggy.\x0D\x0A";
            dlg.m_info+="    -Q  Quiet: Suppresses all explanation of what Triangle is doing, unless\x0D\x0A"
;
            dlg.m_info+="        an error occurs.\x0D\x0A";
            dlg.m_info+="    -V  Verbose: Gives detailed information about what Triangle is doing.\x0D\x0A";
            dlg.m_info+="        Add more `V's for increasing amount of detail.  `-V' gives\x0D\x0A";
            dlg.m_info+="        information on algorithmic progress and more detailed statistics.\x0D\x0A";
            dlg.m_info+="        `-VV' gives point-by-point details, and will print so much that\x0D\x0A";
            dlg.m_info+="        Triangle will run much more slowly.  `-VVV' gives information only\x0D\x0A"
;
            dlg.m_info+="        a debugger could love.\x0D\x0A";
            dlg.m_info+="    -h  Help:  Displays these instructions.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+="Definitions:\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+="  A Delaunay triangulation of a point set is a triangulation whose vertices\x0D\x0A"
;
            dlg.m_info+="  are the point set, having the property that no point in the point set\x0D\x0A";
            dlg.m_info+=
"  falls in the interior of the circumcircle (circle that passes through all\x0D\x0A"
;
            dlg.m_info+="  three vertices) of any triangle in the triangulation.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  A Voronoi diagram of a point set is a subdivision of the plane into\x0D\x0A";
            dlg.m_info+=
"  polygonal regions (some of which may be infinite), where each region is\x0D\x0A";
            dlg.m_info+=
"  the set of points in the plane that are closer to some input point than\x0D\x0A";
            dlg.m_info+=
"  to any other input point.  (The Voronoi diagram is the geometric dual of\x0D\x0A"
;
            dlg.m_info+="  the Delaunay triangulation.)\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  A Planar Straight Line Graph (PSLG) is a collection of points and\x0D\x0A";
            dlg.m_info+=
"  segments.  Segments are simply edges, whose endpoints are points in the\x0D\x0A";
            dlg.m_info+=
"  PSLG.  The file format for PSLGs (.poly files) is described below.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"  A constrained Delaunay triangulation of a PSLG is similar to a Delaunay\x0D\x0A";
            dlg.m_info+=
"  triangulation, but each PSLG segment is present as a single edge in the\x0D\x0A";
            dlg.m_info+=
"  triangulation.  (A constrained Delaunay triangulation is not truly a\x0D\x0A";
            dlg.m_info+="  Delaunay triangulation.)\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  A conforming Delaunay triangulation of a PSLG is a true Delaunay\x0D\x0A";
            dlg.m_info+=
"  triangulation in which each PSLG segment may have been subdivided into\x0D\x0A";
            dlg.m_info+=
"  several edges by the insertion of additional points.  These inserted\x0D\x0A";
            dlg.m_info+=
"  points are necessary to allow the segments to exist in the mesh while\x0D\x0A";
            dlg.m_info+="  maintaining the Delaunay property.\x0D\x0A\x0D\x0A";
            dlg.m_info+="File Formats:\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  All files may contain comments prefixed by the character '#'.  Points,\x0D\x0A";
            dlg.m_info+=
"  triangles, edges, holes, and maximum area constraints must be numbered\x0D\x0A";
            dlg.m_info+=
"  consecutively, starting from either 1 or 0.  Whichever you choose, all\x0D\x0A";
            dlg.m_info+=
"  input files must be consistent; if the nodes are numbered from 1, so must\x0D\x0A"
;
            dlg.m_info+=
"  be all other objects.  Triangle automatically detects your choice while\x0D\x0A";
            dlg.m_info+=
"  reading the .node (or .poly) file.  (When calling Triangle from another\x0D\x0A";
            dlg.m_info+=
"  program, use the -z switch if you wish to number objects from zero.)\x0D\x0A";
            dlg.m_info+="  Examples of these file formats are given below.\x0D\x0A\x0D\x0A";
            dlg.m_info+="  .node files:\x0D\x0A";
            dlg.m_info+=
"    First line:  <# of points> <dimension (must be 2)> <# of attributes>\x0D\x0A";
            dlg.m_info+=
"                                           <# of boundary markers (0 or 1)>\x0D\x0A"
;
            dlg.m_info+=
"    Remaining lines:  <point #> <x> <y> [attributes] [boundary marker]\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    The attributes, which are typically floating-point values of physical\x0D\x0A";
            dlg.m_info+=
"    quantities (such as mass or conductivity) associated with the nodes of\x0D\x0A"
;
            dlg.m_info+=
"    a finite element mesh, are copied unchanged to the output mesh.  If -s,\x0D\x0A"
;
            dlg.m_info+=
"    -q, or -a is selected, each new Steiner point added to the mesh will\x0D\x0A";
            dlg.m_info+="    have attributes assigned to it by linear interpolation.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    If the fourth entry of the first line is `1', the last column of the\x0D\x0A";
            dlg.m_info+=
"    remainder of the file is assumed to contain boundary markers.  Boundary\x0D\x0A"
;
            dlg.m_info+=
"    markers are used to identify boundary points and points resting on PSLG\x0D\x0A"
;
            dlg.m_info+=
"    segments; a complete description appears in a section below.  The .node\x0D\x0A"
;
            dlg.m_info+=
"    file produced by Triangle will contain boundary markers in the last\x0D\x0A";
            dlg.m_info+="    column unless they are suppressed by the -B switch.\x0D\x0A\x0D\x0A";
            dlg.m_info+="  .ele files:\x0D\x0A";
            dlg.m_info+=
"    First line:  <# of triangles> <points per triangle> <# of attributes>\x0D\x0A";
            dlg.m_info+=
"    Remaining lines:  <triangle #> <point> <point> <point> ... [attributes]\x0D\x0A"
;
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    Points are indices into the corresponding .node file.  The first three\x0D\x0A"
;
            dlg.m_info+=
"    points are the corners, and are listed in counterclockwise order around\x0D\x0A"
;
            dlg.m_info+=
"    each triangle.  (The remaining points, if any, depend on the type of\x0D\x0A";
            dlg.m_info+=
"    finite element used.)  The attributes are just like those of .node\x0D\x0A";
            dlg.m_info+=
"    files.  Because there is no simple mapping from input to output\x0D\x0A";
            dlg.m_info+=
"    triangles, an attempt is made to interpolate attributes, which may\x0D\x0A";
            dlg.m_info+=
"    result in a good deal of diffusion of attributes among nearby triangles\x0D\x0A"
;
            dlg.m_info+=
"    as the triangulation is refined.  Diffusion does not occur across\x0D\x0A";
            dlg.m_info+=
"    segments, so attributes used to identify segment-bounded regions remain\x0D\x0A"
;
            dlg.m_info+=
"    intact.  In output .ele files, all triangles have three points each\x0D\x0A";
            dlg.m_info+=
"    unless the -o2 switch is used, in which case they have six, and the\x0D\x0A";
            dlg.m_info+=
"    fourth, fifth, and sixth points lie on the midpoints of the edges\x0D\x0A";
            dlg.m_info+="    opposite the first, second, and third corners.\x0D\x0A\x0D\x0A";
            dlg.m_info+="  .poly files:\x0D\x0A";
            dlg.m_info+=
"    First line:  <# of points> <dimension (must be 2)> <# of attributes>\x0D\x0A";
            dlg.m_info+=
"                                           <# of boundary markers (0 or 1)>\x0D\x0A"
;
            dlg.m_info+=
"    Following lines:  <point #> <x> <y> [attributes] [boundary marker]\x0D\x0A";
            dlg.m_info+="    One line:  <# of segments> <# of boundary markers (0 or 1)>\x0D\x0A";
            dlg.m_info+=
"    Following lines:  <segment #> <endpoint> <endpoint> [boundary marker]\x0D\x0A";
            dlg.m_info+="    One line:  <# of holes>\x0D\x0A";
            dlg.m_info+="    Following lines:  <hole #> <x> <y>\x0D\x0A";
            dlg.m_info+=
"    Optional line:  <# of regional attributes and/or area constraints>\x0D\x0A";
            dlg.m_info+=
"    Optional following lines:  <constraint #> <x> <y> <attrib> <max area>\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    A .poly file represents a PSLG, as well as some additional information.\x0D\x0A"
;
            dlg.m_info+=
"    The first section lists all the points, and is identical to the format\x0D\x0A"
;
            dlg.m_info+=
"    of .node files.  <# of points> may be set to zero to indicate that the\x0D\x0A"
;
            dlg.m_info+=
"    points are listed in a separate .node file; .poly files produced by\x0D\x0A";
            dlg.m_info+=
"    Triangle always have this format.  This has the advantage that a point\x0D\x0A"
;
            dlg.m_info+=
"    set may easily be triangulated with or without segments.  (The same\x0D\x0A";
            dlg.m_info+=
"    effect can be achieved, albeit using more disk space, by making a copy\x0D\x0A"
;
            dlg.m_info+=
"    of the .poly file with the extension .node; all sections of the file\x0D\x0A";
            dlg.m_info+="    but the first are ignored.)\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    The second section lists the segments.  Segments are edges whose\x0D\x0A";
            dlg.m_info+=
"    presence in the triangulation is enforced.  Each segment is specified\x0D\x0A";
            dlg.m_info+=
"    by listing the indices of its two endpoints.  This means that you must\x0D\x0A"
;
            dlg.m_info+=
"    include its endpoints in the point list.  If -s, -q, and -a are not\x0D\x0A";
            dlg.m_info+=
"    selected, Triangle will produce a constrained Delaunay triangulation,\x0D\x0A";
            dlg.m_info+=
"    in which each segment appears as a single edge in the triangulation.\x0D\x0A";
            dlg.m_info+=
"    If -q or -a is selected, Triangle will produce a conforming Delaunay\x0D\x0A";
            dlg.m_info+=
"    triangulation, in which segments may be subdivided into smaller edges.\x0D\x0A"
;
            dlg.m_info+="    Each segment, like each point, may have a boundary marker.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    The third section lists holes (and concavities, if -c is selected) in\x0D\x0A";
            dlg.m_info+=
"    the triangulation.  Holes are specified by identifying a point inside\x0D\x0A";
            dlg.m_info+=
"    each hole.  After the triangulation is formed, Triangle creates holes\x0D\x0A";
            dlg.m_info+=
"    by eating triangles, spreading out from each hole point until its\x0D\x0A";
            dlg.m_info+=
"    progress is blocked by PSLG segments; you must be careful to enclose\x0D\x0A";
            dlg.m_info+=
"    each hole in segments, or your whole triangulation may be eaten away.\x0D\x0A";
            dlg.m_info+=
"    If the two triangles abutting a segment are eaten, the segment itself\x0D\x0A";
            dlg.m_info+=
"    is also eaten.  Do not place a hole directly on a segment; if you do,\x0D\x0A";
            dlg.m_info+="    Triangle will choose one side of the segment arbitrarily.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    The optional fourth section lists regional attributes (to be assigned\x0D\x0A";
            dlg.m_info+=
"    to all triangles in a region) and regional constraints on the maximum\x0D\x0A";
            dlg.m_info+=
"    triangle area.  Triangle will read this section only if the -A switch\x0D\x0A";
            dlg.m_info+=
"    is used or the -a switch is used without a number following it, and the\x0D\x0A"
;
            dlg.m_info+=
"    -r switch is not used.  Regional attributes and area constraints are\x0D\x0A";
            dlg.m_info+=
"    propagated in the same manner as holes; you specify a point for each\x0D\x0A";
            dlg.m_info+=
"    attribute and/or constraint, and the attribute and/or constraint will\x0D\x0A";
            dlg.m_info+=
"    affect the whole region (bounded by segments) containing the point.  If\x0D\x0A"
;
            dlg.m_info+=
"    two values are written on a line after the x and y coordinate, the\x0D\x0A";
            dlg.m_info+=
"    former is assumed to be a regional attribute (but will only be applied\x0D\x0A"
;
            dlg.m_info+=
"    if the -A switch is selected), and the latter is assumed to be a\x0D\x0A";
            dlg.m_info+=
"    regional area constraint (but will only be applied if the -a switch is\x0D\x0A"
;
            dlg.m_info+=
"    selected).  You may also specify just one value after the coordinates,\x0D\x0A"
;
            dlg.m_info+=
"    which can serve as both an attribute and an area constraint, depending\x0D\x0A"
;
            dlg.m_info+=
"    on the choice of switches.  If you are using the -A and -a switches\x0D\x0A";
            dlg.m_info+=
"    simultaneously and wish to assign an attribute to some region without\x0D\x0A";
            dlg.m_info+="    imposing an area constraint, use a negative maximum area.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    When a triangulation is created from a .poly file, you must either\x0D\x0A";
            dlg.m_info+=
"    enclose the entire region to be triangulated in PSLG segments, or\x0D\x0A";
            dlg.m_info+=
"    use the -c switch, which encloses the convex hull of the input point\x0D\x0A";
            dlg.m_info+=
"    set.  If you do not use the -c switch, Triangle will eat all triangles\x0D\x0A"
;
            dlg.m_info+=
"    on the outer boundary that are not protected by segments; if you are\x0D\x0A";
            dlg.m_info+=
"    not careful, your whole triangulation may be eaten away.  If you do\x0D\x0A";
            dlg.m_info+=
"    use the -c switch, you can still produce concavities by appropriate\x0D\x0A";
            dlg.m_info+="    placement of holes just inside the convex hull.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    An ideal PSLG has no intersecting segments, nor any points that lie\x0D\x0A";
            dlg.m_info+=
"    upon segments (except, of course, the endpoints of each segment.)  You\x0D\x0A"
;
            dlg.m_info+=
"    aren't required to make your .poly files ideal, but you should be aware\x0D\x0A"
;
            dlg.m_info+=
"    of what can go wrong.  Segment intersections are relatively safe -\x0D\x0A";
            dlg.m_info+=
"    Triangle will calculate the intersection points for you and add them to\x0D\x0A"
;
            dlg.m_info+=
"    the triangulation - as long as your machine's floating-point precision\x0D\x0A"
;
            dlg.m_info+=
"    doesn't become a problem.  You are tempting the fates if you have three\x0D\x0A"
;
            dlg.m_info+=
"    segments that cross at the same location, and expect Triangle to figure\x0D\x0A"
;
            dlg.m_info+=
"    out where the intersection point is.  Thanks to floating-point roundoff\x0D\x0A"
;
            dlg.m_info+=
"    error, Triangle will probably decide that the three segments intersect\x0D\x0A"
;
            dlg.m_info+=
"    at three different points, and you will find a minuscule triangle in\x0D\x0A";
            dlg.m_info+=
"    your output - unless Triangle tries to refine the tiny triangle, uses\x0D\x0A";
            dlg.m_info+=
"    up the last bit of machine precision, and fails to terminate at all.\x0D\x0A";
            dlg.m_info+=
"    You're better off putting the intersection point in the input files,\x0D\x0A";
            dlg.m_info+=
"    and manually breaking up each segment into two.  Similarly, if you\x0D\x0A";
            dlg.m_info+=
"    place a point at the middle of a segment, and hope that Triangle will\x0D\x0A";
            dlg.m_info+=
"    break up the segment at that point, you might get lucky.  On the other\x0D\x0A"
;
            dlg.m_info+=
"    hand, Triangle might decide that the point doesn't lie precisely on the\x0D\x0A"
;
            dlg.m_info+=
"    line, and you'll have a needle-sharp triangle in your output - or a lot\x0D\x0A"
;
            dlg.m_info+="    of tiny triangles if you're generating a quality mesh.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    When Triangle reads a .poly file, it also writes a .poly file, which\x0D\x0A";
            dlg.m_info+=
"    includes all edges that are part of input segments.  If the -c switch\x0D\x0A";
            dlg.m_info+=
"    is used, the output .poly file will also include all of the edges on\x0D\x0A";
            dlg.m_info+=
"    the convex hull.  Hence, the output .poly file is useful for finding\x0D\x0A";
            dlg.m_info+=
"    edges associated with input segments and setting boundary conditions in\x0D\x0A"
;
            dlg.m_info+=
"    finite element simulations.  More importantly, you will need it if you\x0D\x0A"
;
            dlg.m_info+=
"    plan to refine the output mesh, and don't want segments to be missing\x0D\x0A";
            dlg.m_info+="    in later triangulations.\x0D\x0A\x0D\x0A";
            dlg.m_info+="  .area files:\x0D\x0A";
            dlg.m_info+="    First line:  <# of triangles>\x0D\x0A";
            dlg.m_info+="    Following lines:  <triangle #> <maximum area>\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    An .area file associates with each triangle a maximum area that is used\x0D\x0A"
;
            dlg.m_info+=
"    for mesh refinement.  As with other file formats, every triangle must\x0D\x0A";
            dlg.m_info+=
"    be represented, and they must be numbered consecutively.  A triangle\x0D\x0A";
            dlg.m_info+=
"    may be left unconstrained by assigning it a negative maximum area.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+="  .edge files:\x0D\x0A";
            dlg.m_info+="    First line:  <# of edges> <# of boundary markers (0 or 1)>\x0D\x0A";
            dlg.m_info+=
"    Following lines:  <edge #> <endpoint> <endpoint> [boundary marker]\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    Endpoints are indices into the corresponding .node file.  Triangle can\x0D\x0A"
;
            dlg.m_info+=
"    produce .edge files (use the -e switch), but cannot read them.  The\x0D\x0A";
            dlg.m_info+=
"    optional column of boundary markers is suppressed by the -B switch.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    In Voronoi diagrams, one also finds a special kind of edge that is an\x0D\x0A";
            dlg.m_info+=
"    infinite ray with only one endpoint.  For these edges, a different\x0D\x0A";
            dlg.m_info+="    format is used:\x0D\x0A\x0D\x0A";
            dlg.m_info+="        <edge #> <endpoint> -1 <direction x> <direction y>\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"    The `direction' is a floating-point vector that indicates the direction\x0D\x0A"
;
            dlg.m_info+="    of the infinite ray.\x0D\x0A\x0D\x0A";
            dlg.m_info+="  .neigh files:\x0D\x0A";
            dlg.m_info+=
"    First line:  <# of triangles> <# of neighbors per triangle (always 3)>\x0D\x0A"
;
            dlg.m_info+=
"    Following lines:  <triangle #> <neighbor> <neighbor> <neighbor>\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    Neighbors are indices into the corresponding .ele file.  An index of -1\x0D\x0A"
;
            dlg.m_info+=
"    indicates a mesh boundary, and therefore no neighbor.  Triangle can\x0D\x0A";
            dlg.m_info+=
"    produce .neigh files (use the -n switch), but cannot read them.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"    The first neighbor of triangle i is opposite the first corner of\x0D\x0A";
            dlg.m_info+="    triangle i, and so on.\x0D\x0A\x0D\x0A";
            dlg.m_info+="Boundary Markers:\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  Boundary markers are tags used mainly to identify which output points and\x0D\x0A"
;
            dlg.m_info+=
"  edges are associated with which PSLG segment, and to identify which\x0D\x0A";
            dlg.m_info+=
"  points and edges occur on a boundary of the triangulation.  A common use\x0D\x0A"
;
            dlg.m_info+=
"  is to determine where boundary conditions should be applied to a finite\x0D\x0A";
            dlg.m_info+=
"  element mesh.  You can prevent boundary markers from being written into\x0D\x0A";
            dlg.m_info+="  files produced by Triangle by using the -B switch.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  The boundary marker associated with each segment in an output .poly file\x0D\x0A"
;
            dlg.m_info+="  or edge in an output .edge file is chosen as follows:\x0D\x0A";
            dlg.m_info+=
"    - If an output edge is part or all of a PSLG segment with a nonzero\x0D\x0A";
            dlg.m_info+=
"      boundary marker, then the edge is assigned the same marker.\x0D\x0A";
            dlg.m_info+=
"    - Otherwise, if the edge occurs on a boundary of the triangulation\x0D\x0A";
            dlg.m_info+=
"      (including boundaries of holes), then the edge is assigned the marker\x0D\x0A"
;
            dlg.m_info+="      one (1).\x0D\x0A";
            dlg.m_info+="    - Otherwise, the edge is assigned the marker zero (0).\x0D\x0A";
            dlg.m_info+=
"  The boundary marker associated with each point in an output .node file is\x0D\x0A"
;
            dlg.m_info+="  chosen as follows:\x0D\x0A";
            dlg.m_info+=
"    - If a point is assigned a nonzero boundary marker in the input file,\x0D\x0A";
            dlg.m_info+=
"      then it is assigned the same marker in the output .node file.\x0D\x0A";
            dlg.m_info+=
"    - Otherwise, if the point lies on a PSLG segment (including the\x0D\x0A";
            dlg.m_info+=
"      segment's endpoints) with a nonzero boundary marker, then the point\x0D\x0A";
            dlg.m_info+=
"      is assigned the same marker.  If the point lies on several such\x0D\x0A";
            dlg.m_info+="      segments, one of the markers is chosen arbitrarily.\x0D\x0A";
            dlg.m_info+=
"    - Otherwise, if the point occurs on a boundary of the triangulation,\x0D\x0A";
            dlg.m_info+="      then the point is assigned the marker one (1).\x0D\x0A";
            dlg.m_info+="    - Otherwise, the point is assigned the marker zero (0).\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"  If you want Triangle to determine for you which points and edges are on\x0D\x0A";
            dlg.m_info+=
"  the boundary, assign them the boundary marker zero (or use no markers at\x0D\x0A"
;
            dlg.m_info+=
"  all) in your input files.  Alternatively, you can mark some of them and\x0D\x0A";
            dlg.m_info+="  leave others marked zero, allowing Triangle to label them.\x0D\x0A\x0D\x0A";
            dlg.m_info+="Triangulation Iteration Numbers:\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  Because Triangle can read and refine its own triangulations, input\x0D\x0A";
            dlg.m_info+=
"  and output files have iteration numbers.  For instance, Triangle might\x0D\x0A";
            dlg.m_info+=
"  read the files mesh.3.node, mesh.3.ele, and mesh.3.poly, refine the\x0D\x0A";
            dlg.m_info+=
"  triangulation, and output the files mesh.4.node, mesh.4.ele, and\x0D\x0A";
            dlg.m_info+="  mesh.4.poly.  Files with no iteration number are treated as if\x0D\x0A";
            dlg.m_info+=
"  their iteration number is zero; hence, Triangle might read the file\x0D\x0A";
            dlg.m_info+=
"  points.node, triangulate it, and produce the files points.1.node and\x0D\x0A";
            dlg.m_info+="  points.1.ele.\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  Iteration numbers allow you to create a sequence of successively finer\x0D\x0A";
            dlg.m_info+=
"  meshes suitable for multigrid methods.  They also allow you to produce a\x0D\x0A"
;
            dlg.m_info+=
"  sequence of meshes using error estimate-driven mesh refinement.\x0D\x0A";
            dlg.m_info+="\x0D\x0A";
            dlg.m_info+=
"  If you're not using refinement or quality meshing, and you don't like\x0D\x0A";
            dlg.m_info+=
"  iteration numbers, use the -I switch to disable them.  This switch will\x0D\x0A";
            dlg.m_info+=
"  also disable output of .node and .poly files to prevent your input files\x0D\x0A"
;
            dlg.m_info+=
"  from being overwritten.  (If the input is a .poly file that contains its\x0D\x0A"
;
            dlg.m_info+="  own points, a .node file will be written.)\x0D\x0A\x0D\x0A";
            dlg.m_info+="Examples of How to Use Triangle:\x0D\x0A\x0D\x0A";
            dlg.m_info+=
"  `triangle dots' will read points from dots.node, and write their Delaunay\x0D\x0A"
;
            dlg.m_info+=
"  triangulation to dots.1.node and dots.1.ele.  (dots.1.node will be\x0D\x0A";
  dlg.m_info+=
"  identical to dots.node.)  `triangle -I dots' writes the triangulation to\x0D\x0A"
;
  dlg.m_info+=
"  dots.ele instead.  (No additional .node file is needed, so none is\x0D\x0A";
  dlg.m_info+="  written.)\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  `triangle -pe object.1' will read a PSLG from object.1.poly (and possibly\x0D\x0A"
;
  dlg.m_info+=
"  object.1.node, if the points are omitted from object.1.poly) and write\x0D\x0A";
  dlg.m_info+="  their constrained Delaunay triangulation to object.2.node and\x0D\x0A";
  dlg.m_info+=
"  object.2.ele.  The segments will be copied to object.2.poly, and all\x0D\x0A";
  dlg.m_info+="  edges will be written to object.2.edge.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  `triangle -pq31.5a.1 object' will read a PSLG from object.poly (and\x0D\x0A";
  dlg.m_info+=
"  possibly object.node), generate a mesh whose angles are all greater than\x0D\x0A"
;
  dlg.m_info+=
"  31.5 degrees and whose triangles all have area smaller than 0.1, and\x0D\x0A";
  dlg.m_info+=
"  write the mesh to object.1.node and object.1.ele.  Each segment may have\x0D\x0A"
;
  dlg.m_info+=
"  been broken up into multiple edges; the resulting constrained edges are\x0D\x0A";
  dlg.m_info+="  written to object.1.poly.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Here is a sample file `box.poly' describing a square with a square hole:\x0D\x0A"
;
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"    # A box with eight points in 2D, no attributes, one boundary marker.\x0D\x0A";
  dlg.m_info+="    8 2 0 1\x0D\x0A";
  dlg.m_info+="    # Outer box has these vertices:\x0D\x0A";
  dlg.m_info+="     1   0 0   0\x0D\x0A";
  dlg.m_info+="     2   0 3   0\x0D\x0A";
  dlg.m_info+="     3   3 0   0\x0D\x0A";
  dlg.m_info+="     4   3 3   33     # A special marker for this point.\x0D\x0A";
  dlg.m_info+="    # Inner square has these vertices:\x0D\x0A";
  dlg.m_info+="     5   1 1   0\x0D\x0A";
  dlg.m_info+="     6   1 2   0\x0D\x0A";
  dlg.m_info+="     7   2 1   0\x0D\x0A";
  dlg.m_info+="     8   2 2   0\x0D\x0A";
  dlg.m_info+="    # Five segments with boundary markers.\x0D\x0A";
  dlg.m_info+="    5 1\x0D\x0A";
  dlg.m_info+="     1   1 2   5      # Left side of outer box.\x0D\x0A";
  dlg.m_info+="     2   5 7   0      # Segments 2 through 5 enclose the hole.\x0D\x0A";
  dlg.m_info+="     3   7 8   0\x0D\x0A";
  dlg.m_info+="     4   8 6   10\x0D\x0A";
  dlg.m_info+="     5   6 5   0\x0D\x0A";
  dlg.m_info+="    # One hole in the middle of the inner square.\x0D\x0A";
  dlg.m_info+="    1\x0D\x0A";
  dlg.m_info+="     1   1.5 1.5\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Note that some segments are missing from the outer square, so one must\x0D\x0A";
  dlg.m_info+=
"  use the `-c' switch.  After `triangle -pqc box.poly', here is the output\x0D\x0A"
;
  dlg.m_info+=
"  file `box.1.node', with twelve points.  The last four points were added\x0D\x0A";
  dlg.m_info+=
"  to meet the angle constraint.  Points 1, 2, and 9 have markers from\x0D\x0A";
  dlg.m_info+=
"  segment 1.  Points 6 and 8 have markers from segment 4.  All the other\x0D\x0A";
  dlg.m_info+=
"  points but 4 have been marked to indicate that they lie on a boundary.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+="    12  2  0  1\x0D\x0A";
  dlg.m_info+="       1    0   0      5\x0D\x0A";
  dlg.m_info+="       2    0   3      5\x0D\x0A";
  dlg.m_info+="       3    3   0      1\x0D\x0A";
  dlg.m_info+="       4    3   3     33\x0D\x0A";
  dlg.m_info+="       5    1   1      1\x0D\x0A";
  dlg.m_info+="       6    1   2     10\x0D\x0A";
  dlg.m_info+="       7    2   1      1\x0D\x0A";
  dlg.m_info+="       8    2   2     10\x0D\x0A";
  dlg.m_info+="       9    0   1.5    5\x0D\x0A";
  dlg.m_info+="      10    1.5   0    1\x0D\x0A";
  dlg.m_info+="      11    3   1.5    1\x0D\x0A";
  dlg.m_info+="      12    1.5   3    1\x0D\x0A";
  dlg.m_info+="    # Generated by triangle -pqc box.poly\x0D\x0A\x0D\x0A";
  dlg.m_info+="  Here is the output file `box.1.ele', with twelve triangles.\x0D\x0A\x0D\x0A";
  dlg.m_info+="    12  3  0\x0D\x0A";
  dlg.m_info+="       1     5   6   9\x0D\x0A";
  dlg.m_info+="       2    10   3   7\x0D\x0A";
  dlg.m_info+="       3     6   8  12\x0D\x0A";
  dlg.m_info+="       4     9   1   5\x0D\x0A";
  dlg.m_info+="       5     6   2   9\x0D\x0A";
  dlg.m_info+="       6     7   3  11\x0D\x0A";
  dlg.m_info+="       7    11   4   8\x0D\x0A";
  dlg.m_info+="       8     7   5  10\x0D\x0A";
  dlg.m_info+="       9    12   2   6\x0D\x0A";
  dlg.m_info+="      10     8   7  11\x0D\x0A";
  dlg.m_info+="      11     5   1  10\x0D\x0A";
  dlg.m_info+="      12     8   4  12\x0D\x0A";
  dlg.m_info+="    # Generated by triangle -pqc box.poly\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Here is the output file `box.1.poly'.  Note that segments have been added\x0D\x0A"
;
  dlg.m_info+=
"  to represent the convex hull, and some segments have been split by newly\x0D\x0A"
;
  dlg.m_info+=
"  added points.  Note also that <# of points> is set to zero to indicate\x0D\x0A";
  dlg.m_info+="  that the points should be read from the .node file.\x0D\x0A\x0D\x0A";
  dlg.m_info+="    0  2  0  1\x0D\x0A";
  dlg.m_info+="    12  1\x0D\x0A";
  dlg.m_info+="       1     1   9     5\x0D\x0A";
  dlg.m_info+="       2     5   7     1\x0D\x0A";
  dlg.m_info+="       3     8   7     1\x0D\x0A";
  dlg.m_info+="       4     6   8    10\x0D\x0A";
  dlg.m_info+="       5     5   6     1\x0D\x0A";
  dlg.m_info+="       6     3  10     1\x0D\x0A";
  dlg.m_info+="       7     4  11     1\x0D\x0A";
  dlg.m_info+="       8     2  12     1\x0D\x0A";
  dlg.m_info+="       9     9   2     5\x0D\x0A";
  dlg.m_info+="      10    10   1     1\x0D\x0A";
  dlg.m_info+="      11    11   3     1\x0D\x0A";
  dlg.m_info+="      12    12   4     1\x0D\x0A";
  dlg.m_info+="    1\x0D\x0A";
  dlg.m_info+="       1   1.5 1.5\x0D\x0A";
  dlg.m_info+="    # Generated by triangle -pqc box.poly\x0D\x0A\x0D\x0A";
  dlg.m_info+="Refinement and Area Constraints:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  The -r switch causes a mesh (.node and .ele files) to be read and\x0D\x0A";
  dlg.m_info+=
"  refined.  If the -p switch is also used, a .poly file is read and used to\x0D\x0A"
;
  dlg.m_info+=
"  specify edges that are constrained and cannot be eliminated (although\x0D\x0A";
  dlg.m_info+=
"  they can be divided into smaller edges) by the refinement process.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  When you refine a mesh, you generally want to impose tighter quality\x0D\x0A";
  dlg.m_info+=
"  constraints.  One way to accomplish this is to use -q with a larger\x0D\x0A";
  dlg.m_info+=
"  angle, or -a followed by a smaller area than you used to generate the\x0D\x0A";
  dlg.m_info+=
"  mesh you are refining.  Another way to do this is to create an .area\x0D\x0A";
  dlg.m_info+=
"  file, which specifies a maximum area for each triangle, and use the -a\x0D\x0A";
  dlg.m_info+=
"  switch (without a number following).  Each triangle's area constraint is\x0D\x0A"
;
  dlg.m_info+=
"  applied to that triangle.  Area constraints tend to diffuse as the mesh\x0D\x0A";
  dlg.m_info+=
"  is refined, so if there are large variations in area constraint between\x0D\x0A";
  dlg.m_info+="  adjacent triangles, you may not get the results you want.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  If you are refining a mesh composed of linear (three-node) elements, the\x0D\x0A"
;
  dlg.m_info+=
"  output mesh will contain all the nodes present in the input mesh, in the\x0D\x0A"
;
  dlg.m_info+=
"  same order, with new nodes added at the end of the .node file.  However,\x0D\x0A"
;
  dlg.m_info+=
"  there is no guarantee that each output element is contained in a single\x0D\x0A";
  dlg.m_info+=
"  input element.  Often, output elements will overlap two input elements,\x0D\x0A";
  dlg.m_info+=
"  and input edges are not present in the output mesh.  Hence, a sequence of\x0D\x0A"
;
  dlg.m_info+=
"  refined meshes will form a hierarchy of nodes, but not a hierarchy of\x0D\x0A";
  dlg.m_info+=
"  elements.  If you a refining a mesh of higher-order elements, the\x0D\x0A";
  dlg.m_info+=
"  hierarchical property applies only to the nodes at the corners of an\x0D\x0A";
  dlg.m_info+="  element; other nodes may not be present in the refined mesh.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  It is important to understand that maximum area constraints in .poly\x0D\x0A";
  dlg.m_info+=
"  files are handled differently from those in .area files.  A maximum area\x0D\x0A"
;
  dlg.m_info+=
"  in a .poly file applies to the whole (segment-bounded) region in which a\x0D\x0A"
;
  dlg.m_info+=
"  point falls, whereas a maximum area in an .area file applies to only one\x0D\x0A"
;
  dlg.m_info+=
"  triangle.  Area constraints in .poly files are used only when a mesh is\x0D\x0A";
  dlg.m_info+=
"  first generated, whereas area constraints in .area files are used only to\x0D\x0A"
;
  dlg.m_info+=
"  refine an existing mesh, and are typically based on a posteriori error\x0D\x0A";
  dlg.m_info+=
"  estimates resulting from a finite element simulation on that mesh.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  `triangle -rq25 object.1' will read object.1.node and object.1.ele, then\x0D\x0A"
;
  dlg.m_info+=
"  refine the triangulation to enforce a 25 degree minimum angle, and then\x0D\x0A";
  dlg.m_info+=
"  write the refined triangulation to object.2.node and object.2.ele.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  `triangle -rpaa6.2 z.3' will read z.3.node, z.3.ele, z.3.poly, and\x0D\x0A";
  dlg.m_info+=
"  z.3.area.  After reconstructing the mesh and its segments, Triangle will\x0D\x0A"
;
  dlg.m_info+=
"  refine the mesh so that no triangle has area greater than 6.2, and\x0D\x0A";
  dlg.m_info+=
"  furthermore the triangles satisfy the maximum area constraints in\x0D\x0A";
  dlg.m_info+=
"  z.3.area.  The output is written to z.4.node, z.4.ele, and z.4.poly.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  The sequence `triangle -qa1 x', `triangle -rqa.3 x.1', `triangle -rqa.1\x0D\x0A";
  dlg.m_info+=
"  x.2' creates a sequence of successively finer meshes x.1, x.2, and x.3,\x0D\x0A";
  dlg.m_info+="  suitable for multigrid.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Convex Hulls and Mesh Boundaries:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  If the input is a point set (rather than a PSLG), Triangle produces its\x0D\x0A";
  dlg.m_info+=
"  convex hull as a by-product in the output .poly file if you use the -c\x0D\x0A";
  dlg.m_info+=
"  switch.  There are faster algorithms for finding a two-dimensional convex\x0D\x0A"
;
  dlg.m_info+=
"  hull than triangulation, of course, but this one comes for free.  If the\x0D\x0A"
;
  dlg.m_info+=
"  input is an unconstrained mesh (you are using the -r switch but not the\x0D\x0A";
  dlg.m_info+=
"  -p switch), Triangle produces a list of its boundary edges (including\x0D\x0A";
  dlg.m_info+="  hole boundaries) as a by-product if you use the -c switch.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Voronoi Diagrams:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  The -v switch produces a Voronoi diagram, in files suffixed .v.node and\x0D\x0A";
  dlg.m_info+=
"  .v.edge.  For example, `triangle -v points' will read points.node,\x0D\x0A";
  dlg.m_info+=
"  produce its Delaunay triangulation in points.1.node and points.1.ele,\x0D\x0A";
  dlg.m_info+=
"  and produce its Voronoi diagram in points.1.v.node and points.1.v.edge.\x0D\x0A";
  dlg.m_info+=
"  The .v.node file contains a list of all Voronoi vertices, and the .v.edge\x0D\x0A"
;
  dlg.m_info+=
"  file contains a list of all Voronoi edges, some of which may be infinite\x0D\x0A"
;
  dlg.m_info+=
"  rays.  (The choice of filenames makes it easy to run the set of Voronoi\x0D\x0A";
  dlg.m_info+="  vertices through Triangle, if so desired.)\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  This implementation does not use exact arithmetic to compute the Voronoi\x0D\x0A"
;
  dlg.m_info+=
"  vertices, and does not check whether neighboring vertices are identical.\x0D\x0A"
;
  dlg.m_info+=
"  Be forewarned that if the Delaunay triangulation is degenerate or\x0D\x0A";
  dlg.m_info+=
"  near-degenerate, the Voronoi diagram may have duplicate points, crossing\x0D\x0A"
;
  dlg.m_info+=
"  edges, or infinite rays whose direction vector is zero.  Also, if you\x0D\x0A";
  dlg.m_info+=
"  generate a constrained (as opposed to conforming) Delaunay triangulation,\x0D\x0A"
;
  dlg.m_info+=
"  or if the triangulation has holes, the corresponding Voronoi diagram is\x0D\x0A";
  dlg.m_info+="  likely to have crossing edges and unlikely to make sense.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Mesh Topology:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  You may wish to know which triangles are adjacent to a certain Delaunay\x0D\x0A";
  dlg.m_info+=
"  edge in an .edge file, which Voronoi regions are adjacent to a certain\x0D\x0A";
  dlg.m_info+=
"  Voronoi edge in a .v.edge file, or which Voronoi regions are adjacent to\x0D\x0A"
;
  dlg.m_info+=
"  each other.  All of this information can be found by cross-referencing\x0D\x0A";
  dlg.m_info+=
"  output files with the recollection that the Delaunay triangulation and\x0D\x0A";
  dlg.m_info+="  the Voronoi diagrams are planar duals.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Specifically, edge i of an .edge file is the dual of Voronoi edge i of\x0D\x0A";
  dlg.m_info+=
"  the corresponding .v.edge file, and is rotated 90 degrees counterclock-\x0D\x0A";
  dlg.m_info+=
"  wise from the Voronoi edge.  Triangle j of an .ele file is the dual of\x0D\x0A";
  dlg.m_info+=
"  vertex j of the corresponding .v.node file; and Voronoi region k is the\x0D\x0A";
  dlg.m_info+="  dual of point k of the corresponding .node file.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Hence, to find the triangles adjacent to a Delaunay edge, look at the\x0D\x0A";
  dlg.m_info+=
"  vertices of the corresponding Voronoi edge; their dual triangles are on\x0D\x0A";
  dlg.m_info+=
"  the left and right of the Delaunay edge, respectively.  To find the\x0D\x0A";
  dlg.m_info+=
"  Voronoi regions adjacent to a Voronoi edge, look at the endpoints of the\x0D\x0A"
;
  dlg.m_info+=
"  corresponding Delaunay edge; their dual regions are on the right and left\x0D\x0A"
;
  dlg.m_info+=
"  of the Voronoi edge, respectively.  To find which Voronoi regions are\x0D\x0A";
  dlg.m_info+="  adjacent to each other, just read the list of Delaunay edges.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+="Statistics:\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  After generating a mesh, Triangle prints a count of the number of points,\x0D\x0A"
;
  dlg.m_info+=
"  triangles, edges, boundary edges, and segments in the output mesh.  If\x0D\x0A";
  dlg.m_info+=
"  you've forgotten the statistics for an existing mesh, the -rNEP switches\x0D\x0A"
;
  dlg.m_info+=
"  (or -rpNEP if you've got a .poly file for the existing mesh) will\x0D\x0A";
  dlg.m_info+="  regenerate these statistics without writing any output.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  The -V switch produces extended statistics, including a rough estimate\x0D\x0A";
  dlg.m_info+=
"  of memory use and a histogram of triangle aspect ratios and angles in the\x0D\x0A"
;
  dlg.m_info+="  mesh.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Exact Arithmetic:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Triangle uses adaptive exact arithmetic to perform what computational\x0D\x0A";
  dlg.m_info+=
"  geometers call the `orientation' and `incircle' tests.  If the floating-\x0D\x0A"
;
  dlg.m_info+=
"  point arithmetic of your machine conforms to the IEEE 754 standard (as\x0D\x0A";
  dlg.m_info+=
"  most workstations do), and does not use extended precision internal\x0D\x0A";
  dlg.m_info+=
"  registers, then your output is guaranteed to be an absolutely true\x0D\x0A";
  dlg.m_info+="  Delaunay or conforming Delaunay triangulation, roundoff error\x0D\x0A";
  dlg.m_info+=
"  notwithstanding.  The word `adaptive' implies that these arithmetic\x0D\x0A";
  dlg.m_info+=
"  routines compute the result only to the precision necessary to guarantee\x0D\x0A"
;
  dlg.m_info+=
"  correctness, so they are usually nearly as fast as their approximate\x0D\x0A";
  dlg.m_info+=
"  counterparts.  The exact tests can be disabled with the -X switch.  On\x0D\x0A";
  dlg.m_info+=
"  most inputs, this switch will reduce the computation time by about eight\x0D\x0A"
;
  dlg.m_info+=
"  percent - it's not worth the risk.  There are rare difficult inputs\x0D\x0A";
  dlg.m_info+=
"  (having many collinear and cocircular points), however, for which the\x0D\x0A";
  dlg.m_info+=
"  difference could be a factor of two.  These are precisely the inputs most\x0D\x0A"
;
  dlg.m_info+="  likely to cause errors if you use the -X switch.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Unfortunately, these routines don't solve every numerical problem.  Exact\x0D\x0A"
;
  dlg.m_info+=
"  arithmetic is not used to compute the positions of points, because the\x0D\x0A";
  dlg.m_info+=
"  bit complexity of point coordinates would grow without bound.  Hence,\x0D\x0A";
  dlg.m_info+=
"  segment intersections aren't computed exactly; in very unusual cases,\x0D\x0A";
  dlg.m_info+=
"  roundoff error in computing an intersection point might actually lead to\x0D\x0A"
;
  dlg.m_info+=
"  an inverted triangle and an invalid triangulation.  (This is one reason\x0D\x0A";
  dlg.m_info+=
"  to compute your own intersection points in your .poly files.)  Similarly,\x0D\x0A"
;
  dlg.m_info+=
"  exact arithmetic is not used to compute the vertices of the Voronoi\x0D\x0A";
  dlg.m_info+="  diagram.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Underflow and overflow can also cause difficulties; the exact arithmetic\x0D\x0A"
;
  dlg.m_info+=
"  routines do not ameliorate out-of-bounds exponents, which can arise\x0D\x0A";
  dlg.m_info+=
"  during the orientation and incircle tests.  As a rule of thumb, you\x0D\x0A";
  dlg.m_info+=
"  should ensure that your input values are within a range such that their\x0D\x0A";
  dlg.m_info+=
"  third powers can be taken without underflow or overflow.  Underflow can\x0D\x0A";
  dlg.m_info+=
"  silently prevent the tests from being performed exactly, while overflow\x0D\x0A";
  dlg.m_info+="  will typically cause a floating exception.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Calling Triangle from Another Program:\x0D\x0A\x0D\x0A";
  dlg.m_info+="  Read the file triangle.h for details.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Troubleshooting:\x0D\x0A\x0D\x0A";
  dlg.m_info+="  Please read this section before mailing me bugs.\x0D\x0A\x0D\x0A";
  dlg.m_info+="  `My output mesh has no triangles!'\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"    If you're using a PSLG, you've probably failed to specify a proper set\x0D\x0A"
;
  dlg.m_info+=
"    of bounding segments, or forgotten to use the -c switch.  Or you may\x0D\x0A";
  dlg.m_info+=
"    have placed a hole badly.  To test these possibilities, try again with\x0D\x0A"
;
  dlg.m_info+=
"    the -c and -O switches.  Alternatively, all your input points may be\x0D\x0A";
  dlg.m_info+=
"    collinear, in which case you can hardly expect to triangulate them.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+="  `Triangle doesn't terminate, or just crashes.'\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"    Bad things can happen when triangles get so small that the distance\x0D\x0A";
  dlg.m_info+=
"    between their vertices isn't much larger than the precision of your\x0D\x0A";
  dlg.m_info+=
"    machine's arithmetic.  If you've compiled Triangle for single-precision\x0D\x0A"
;
  dlg.m_info+=
"    arithmetic, you might do better by recompiling it for double-precision.\x0D\x0A"
;
  dlg.m_info+=
"    Then again, you might just have to settle for more lenient constraints\x0D\x0A"
;
  dlg.m_info+=
"    on the minimum angle and the maximum area than you had planned.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"    You can minimize precision problems by ensuring that the origin lies\x0D\x0A";
  dlg.m_info+=
"    inside your point set, or even inside the densest part of your\x0D\x0A";
  dlg.m_info+=
"    mesh.  On the other hand, if you're triangulating an object whose x\x0D\x0A";
  dlg.m_info+=
"    coordinates all fall between 6247133 and 6247134, you're not leaving\x0D\x0A";
  dlg.m_info+="    much floating-point precision for Triangle to work with.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"    Precision problems can occur covertly if the input PSLG contains two\x0D\x0A";
  dlg.m_info+=
"    segments that meet (or intersect) at a very small angle, or if such an\x0D\x0A"
;
  dlg.m_info+=
"    angle is introduced by the -c switch, which may occur if a point lies\x0D\x0A";
  dlg.m_info+=
"    ever-so-slightly inside the convex hull, and is connected by a PSLG\x0D\x0A";
  dlg.m_info+=
"    segment to a point on the convex hull.  If you don't realize that a\x0D\x0A";
  dlg.m_info+=
"    small angle is being formed, you might never discover why Triangle is\x0D\x0A";
  dlg.m_info+=
"    crashing.  To check for this possibility, use the -S switch (with an\x0D\x0A";
  dlg.m_info+=
"    appropriate limit on the number of Steiner points, found by trial-and-\x0D\x0A"
;
  dlg.m_info+=
"    error) to stop Triangle early, and view the output .poly file with\x0D\x0A";
  dlg.m_info+=
"    Show Me (described below).  Look carefully for small angles between\x0D\x0A";
  dlg.m_info+=
"    segments; zoom in closely, as such segments might look like a single\x0D\x0A";
  dlg.m_info+="    segment from a distance.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"    If some of the input values are too large, Triangle may suffer a\x0D\x0A";
  dlg.m_info+=
"    floating exception due to overflow when attempting to perform an\x0D\x0A";
  dlg.m_info+=
"    orientation or incircle test.  (Read the section on exact arithmetic\x0D\x0A";
  dlg.m_info+=
"    above.)  Again, I recommend compiling Triangle for double (rather\x0D\x0A";
  dlg.m_info+="    than single) precision arithmetic.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  `The numbering of the output points doesn't match the input points.'\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"    You may have eaten some of your input points with a hole, or by placing\x0D\x0A"
;
  dlg.m_info+="    them outside the area enclosed by segments.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  `Triangle executes without incident, but when I look at the resulting\x0D\x0A";
  dlg.m_info+=
"  mesh, it has overlapping triangles or other geometric inconsistencies.'\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"    If you select the -X switch, Triangle's divide-and-conquer Delaunay\x0D\x0A";
  dlg.m_info+=
"    triangulation algorithm occasionally makes mistakes due to floating-\x0D\x0A";
  dlg.m_info+=
"    point roundoff error.  Although these errors are rare, don't use the -X\x0D\x0A"
;
  dlg.m_info+="    switch.  If you still have problems, please report the bug.\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  Strange things can happen if you've taken liberties with your PSLG.  Do\x0D\x0A";
  dlg.m_info+=
"  you have a point lying in the middle of a segment?  Triangle sometimes\x0D\x0A";
  dlg.m_info+=
"  copes poorly with that sort of thing.  Do you want to lay out a collinear\x0D\x0A"
;
  dlg.m_info+=
"  row of evenly spaced, segment-connected points?  Have you simply defined\x0D\x0A"
;
  dlg.m_info+=
"  one long segment connecting the leftmost point to the rightmost point,\x0D\x0A";
  dlg.m_info+=
"  and a bunch of points lying along it?  This method occasionally works,\x0D\x0A";
  dlg.m_info+=
"  especially with horizontal and vertical lines, but often it doesn't, and\x0D\x0A"
;
  dlg.m_info+=
"  you'll have to connect each adjacent pair of points with a separate\x0D\x0A";
  dlg.m_info+="  segment.  If you don't like it, tough.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Furthermore, if you have segments that intersect other than at their\x0D\x0A";
  dlg.m_info+=
"  endpoints, try not to let the intersections fall extremely close to PSLG\x0D\x0A"
;
  dlg.m_info+="  points or each other.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  If you have problems refining a triangulation not produced by Triangle:\x0D\x0A";
  dlg.m_info+=
"  Are you sure the triangulation is geometrically valid?  Is it formatted\x0D\x0A";
  dlg.m_info+=
"  correctly for Triangle?  Are the triangles all listed so the first three\x0D\x0A"
;
  dlg.m_info+="  points are their corners in counterclockwise order?\x0D\x0A\x0D\x0A";
  dlg.m_info+="Show Me:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Triangle comes with a separate program named `Show Me', whose primary\x0D\x0A";
  dlg.m_info+=
"  purpose is to draw meshes on your screen or in PostScript.  Its secondary\x0D\x0A"
;
  dlg.m_info+=
"  purpose is to check the validity of your input files, and do so more\x0D\x0A";
  dlg.m_info+=
"  thoroughly than Triangle does.  Show Me requires that you have the X\x0D\x0A";
  dlg.m_info+=
"  Windows system.  If you didn't receive Show Me with Triangle, complain to\x0D\x0A"
;
  dlg.m_info+="  whomever you obtained Triangle from, then send me mail.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Triangle on the Web:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  To see an illustrated, updated version of these instructions, check out\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+="    http://www.cs.cmu.edu/~quake/triangle.html\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+="A Brief Plea:\x0D\x0A";
  dlg.m_info+="\x0D\x0A";
  dlg.m_info+=
"  If you use Triangle, and especially if you use it to accomplish real\x0D\x0A";
  dlg.m_info+=
"  work, I would like very much to hear from you.  A short letter or email\x0D\x0A";
  dlg.m_info+=
"  (to jrs@cs.cmu.edu) describing how you use Triangle will mean a lot to\x0D\x0A";
  dlg.m_info+=
"  me.  The more people I know are using this program, the more easily I can\x0D\x0A"
;
  dlg.m_info+=
"  justify spending time on improvements and on the three-dimensional\x0D\x0A";
  dlg.m_info+=
"  successor to Triangle, which in turn will benefit you.  Also, I can put\x0D\x0A";
  dlg.m_info+=
"  you on a list to receive email whenever a new version of Triangle is\x0D\x0A";
  dlg.m_info+="  available.\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  If you use a mesh generated by Triangle in a publication, please include\x0D\x0A"
;
  dlg.m_info+="  an acknowledgment as well.\x0D\x0A\x0D\x0A";
  dlg.m_info+="Research credit:\x0D\x0A\x0D\x0A";
  dlg.m_info+=
"  Of course, I can take credit for only a fraction of the ideas that made\x0D\x0A";
  dlg.m_info+=
"  this mesh generator possible.  Triangle owes its existence to the efforts\x0D\x0A"
;
  dlg.m_info+=
"  of many fine computational geometers and other researchers, including\x0D\x0A";
  dlg.m_info+=
"  Marshall Bern, L. Paul Chew, Boris Delaunay, Rex A. Dwyer, David\x0D\x0A";
  dlg.m_info+=
"  Eppstein, Steven Fortune, Leonidas J. Guibas, Donald E. Knuth, C. L.\x0D\x0A";
  dlg.m_info+=
"  Lawson, Der-Tsai Lee, Ernst P. Mucke, Douglas M. Priest, Jim Ruppert,\x0D\x0A";
  dlg.m_info+=
"  Isaac Saias, Bruce J. Schachter, Micha Sharir, Jorge Stolfi, Christopher\x0D\x0A"
;
  dlg.m_info+=
"  J. Van Wyk, David F. Watson, and Binhai Zhu.  See the comments at the\x0D\x0A";
  dlg.m_info+="  beginning of the source code for references.\x0D\x0A\x0D\x0A";
  }

	if(bRunTriangle==TRUE)
		_beginthread( old_main, 0, (void *) &dlg  );

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
